// C Source File
// Created 12/15/00; 11:22:53 PM

// Available Patches
// #define USE_LONGMUL_PATCH
// #define USE_LONGDIV_PATCH
// #define USE_INITS_PATCH

#define OPTIMIZE_ROM_CALLS    // Use Speed Optimization

//#define SAVE_SCREEN           // Save/Restore LCD Contents

//#define NO_EXIT_SUPPORT

#include <tigcclib.h>         // Include All Header Files

#include "extgraph.h"

//short _ti89;                    // Produce .89Z File
short _v200;



/*for the ti-89
#define ARROWS_ROW 0xfffe      // Constants for low-level keyboard access
#define UP_KEY 1
#define LEFT_KEY 2
#define DOWN_KEY 4
#define RIGHT_KEY 8
#define SECOND_KEY 16
#define SHIFT_KEY 32
#define DIAMOND_KEY 64
#define ALPHA_KEY 128


#define PLUS_ROW 0xfffd
#define PLUS_KEY 2

#define MINUS_ROW 0xfffd
#define MINUS_KEY 4

#define TIMES_ROW 0xfffd
#define TIMES_KEY 8

#define DIVIDE_ROW 0xfffd
#define DIVIDE_KEY 16


#define APPS_ROW 0xffdf
#define APPS_KEY 1

#define HOME_ROW 0xffdf
#define HOME_KEY 64

#define STO_ROW 0xffdf
#define STO_KEY 2



#define F1_ROW 0xffdf
#define F2_ROW 0xffef
#define F3_ROW 0xfff7
#define F4_ROW 0xfffb
#define F5_ROW 0xfffd

#define FX_KEY 128


#define ZERO_ROW 0xffef

#define DOT_ROW 0xfff7

#define NEGATIVE_ROW 0xfffb

*/

#define ZERO_ROW 0xffef

#define DOT_ROW 0xfff7

#define NEGATIVE_ROW 0xfffb

//FOR THE TI92
#define ARROWS_ROW 0xfffe      // Constants for low-level keyboard access
#define UP_KEY 32
#define LEFT_KEY 16
#define DOWN_KEY 128
#define RIGHT_KEY 64
#define SECOND_KEY 1
#define SHIFT_KEY 4
#define DIAMOND_KEY 2
#define ALPHA_KEY 8


#define PLUS_ROW 0xfeff
#define PLUS_KEY 16

#define MINUS_ROW 0xfdff
#define MINUS_KEY 1

#define TIMES_ROW 0xff7f
#define TIMES_KEY 128

#define DIVIDE_ROW 0xffdf
#define DIVIDE_KEY 1



#define APPS_ROW 0xff7f
#define APPS_KEY 64

#define HOME_ROW 0xffdf
#define HOME_KEY 64

#define STO_ROW 0xfff8 //gendert
#define STO_KEY 1

#define F1_ROW 0xffbf
#define F2_ROW 0xffef
#define F3_ROW 0xfffb
#define F4_ROW 0xfdff
#define F5_ROW 0xff7f
#define FX_KEY 16



#define STOP 0
#define MOVE 1
#define ATTACK 2
#define NEARATTACK 5  //ATTACKING ONLY WHILE IN RANGE
#define HARVEST 3
#define UNLOAD 4


#define MAX_UNITS 150
#define MAX_BUILDINGS 50
#define MAX_BULLETS 50
#define MAX_EXPLOSIONS 50
#define MAX_ORDERS 50
#define MAX_TRIGGERS 25
#define MAX_TOBUILDS 30


#define UNIT_VALUES 30
#define UNITTYPE_VALUES 15
#define BULLET_VALUES 12

#define MAX_TIBERIUM 200
#define NUMBER_OF_TYPES_OF_UNITS 34

#define NUMBER_OF_BUILDING_PICS 67
#define NUMBER_OF_UNIT_PICS 214

#define NUMBER_OF_BULLET_PICS 19 //chars
#define NUMBER_OF_SUPER_PICS 4
#define NUMBER_OF_EXPLOSION_PICS 10
#define NUMBER_OF_CURSOR_PICS 11

//map
#define MAXWIDTH 64
#define MAXHEIGHT 64


//super weapons
#define IONCHARGE 70
#define NUKECHARGE 100



//unittype numbers
#define ACOM 29
#define TMPL 30
#define COMM 12
#define PROC 11
#define NUKE 1
#define WEAP 8
#define YARD 0
#define PYLE 7
#define SILO 10
#define TOWR 3
#define ATWR 4
#define OBLI 6
#define BAY 9
#define NUK2 2

#define LASER 12


#define ENGINEER 17
#define COMMANDO 28
#define HARV 26
#define MCV 27
#define LTNK 20
#define MTNK 21
#define MINI 13
#define BTNK 24  //mammoth tank

//orders
#define MOVETO 1
#define GOTOORDER 2
#define ATTACKUNITS 3


//triggers
#define ALLDEAD 1
#define GAMETIME 2
#define UNITDEAD 3
#define EMONEY 4
#define CAPTURE 5
#define DESTINATION 6
#define BUILDUNIT 7
#define MONEY 8
#define INTERVAL 9


#define VICTORY 1
#define DEFEAT 2
#define ORDERUNIT 3
#define ADDEMONEY 4
#define FLARE 5
#define ALLOWVICTORY 6
#define EREINFORCEMENTS 7
#define REINFORCEMENTS 8
#define MESSAGE 9
#define ADDMONEY 10
#define LAUNCHSUPER 11
#define KILLUNIT 12



unsigned short flare[32]=
{0x0000,0x0200,0x04D8,0x0312,0x0040,0x0810,0x0514,0x3020
,0x14C8,0x0000,0x1940,0x02A0,0x0000,0x0E00,0x0000,0x0000
,0x0600,0x0D16,0x0127,0x0C89,0x0BBE,0x066C,0x2AE8,0x07DA
,0x0324,0x1FF8,0x02B0,0x0D40,0x0700,0x0E00,0x0000,0x0000};


unsigned char icon[6][10]=
{
//rifle
{0xA8,0xA8,0xA8,0xA8,0xA8,0xA8,0x00,0x00,0x50,0x50},
//grenade
{0x60,0x20,0xF0,0x00,0x60,0x20,0xF0,0x00,0xF0,0x00},
//fire
{0x00,0x10,0x50,0x70,0x20,0x50,0xE8,0xA8,0x88,0x50},
//rocket
{0x20,0x50,0x50,0x70,0xF8,0x20,0x70,0x70,0xD8,0x50},
//commando
{0x20,0x20,0xD8,0x20,0x20,0x70,0x88,0x88,0x88,0x70},
//engineer
{0x60,0x80,0x88,0x08,0x30,0x40,0xA0,0x70,0x28,0x10}
};

	

unsigned char baddymark[5] = {0x88,0x70,0x70,0x70,0x88};



unsigned char *shell=NULL;
unsigned short *pics=NULL;
unsigned short *superpics=NULL;
unsigned short *cursor=NULL;
unsigned short *explode=NULL;
	
	


struct unittype
{
	int speed,pic,rotate,wartype;//in buildings speed is width and rotate is height of building in squares
	int maxhp,sight,maxstore,cost,powercost,pre1,pre2,armortype,preside,techlevel,icon;
};


struct unit
{
	int col,row,oldcol,oldrow,findestcol,findestrow,destcol,destrow; 
	int x,y,direction,destx,desty,destdir,olddir;
	int curspeed,curcool;
	int side,select,mode,move,type,target;
	//stats
	int hp,store,order,step,repair,trigger,builder;

};



struct bullet
{
	int on;
	int startx,starty,endx,endy,a,b,c,speed,curspeed,wartype,bulletpic;
};

struct warhead
{
	int cooldown,range,damage,speed,spread,accuracy,bulletpic,explosionpic,damagetype;
};


struct explosion
{
	int time,x,y,explodetype;  //for laser line explodetype is start coordinate; x, y is end
};

struct buildque
{
	int y,current,done, oldrow, type;
};



int allmessages[3][2]={{}};
	




int flares[3][2]={{-1,0},{-1,0},{-1,0}};


char messagetext[7][25]=
{
	"Unit under attack",
	"Low on storage space",
	"Ion Cannon charged",
	"Nuke ready to launch",
	"Press alpha+F5 to fire",
	"Reinforcements arrived",
	"Incoming enemy forces"
};


char levelname[10]="";

int curmapx=0,curmapy=0,mapwidth=64,mapheight=64;

//char lightplane[3840],darkplane[3840];


int inview[2]={1,13};


struct buildque allbuilders[3]={};


struct unit (*allunits)=NULL;

struct explosion (*allexplosions)=NULL;

struct bullet (*allbullets)=NULL;

int (*map)[64]= NULL;
unsigned char (*fog)[64]= NULL;

//contains all the tiberium
char (*tmap)[64]=NULL;
	

void *lightplane=NULL;// = malloc (LCD_SIZE);  // Allocate the buffer
void *darkplane=NULL;// = malloc (LCD_SIZE);  // Allocate the buffer
void *sidebarl=NULL;
void *sidebard=NULL;
int *pselectbox=NULL;	
int *pwarning=NULL;	
int *punits=NULL;
int *punittypes=NULL;
int *pbullets=NULL;
int *pexplosions=NULL;

int *pmoney=NULL;

SCR_RECT scr_rect={{0,0,0,0}};
	

	
int yourside=1;
int enemyside=0;		
int techlevel=0;
	
int powerconsumption=0,poweroutput=0;	

int enemypowerconsumption=0,enemypoweroutput=0;


INT_HANDLER save_int_1=0;





	
int checkscr(int x,int y)
{
	//checkstall++;	
	if(x>=curmapx&&x<=curmapx+160&&y>=curmapy-16&&y<=curmapy+100&&fog[y/16][x/16]==0) return TRUE;
	else return FALSE;
}


void putbadmark(int x, int y)
{
	if(checkscr(x-13,y-5)){
	Sprite8_XOR (x-13-curmapx, y-5-curmapy, 5, baddymark, GetPlane(DARK_PLANE)); 
  }
}

void puticonmark(int x, int y, int pic)
{
	if(checkscr(x+8,y-5)&&pic>=0){
	Sprite8_XOR (x+8-curmapx, y-5-curmapy, 5, icon[pic], GetPlane(DARK_PLANE)); 
  Sprite8_XOR (x+8-curmapx, y-5-curmapy, 5, &icon[pic][5], GetPlane(0)); 
  }
  
}


void GraySprite8 (short x, short y, short h, unsigned char *sprite)
{
	if(checkscr(x,y)){
	Sprite8_XOR (x-curmapx, y-curmapy, h, sprite, GetPlane(DARK_PLANE)); 
  Sprite8_XOR (x-curmapx, y-curmapy, h, sprite+8, GetPlane(LIGHT_PLANE));  
	}
}

void GrayRect(int x1, int y1, int x2, int y2, int mode)
{
	do{
	switch(mode)
	{
		case 0: case 2: SetPlane(LIGHT_PLANE); break;
		case 1:  SetPlane(DARK_PLANE);
	}
	DrawClipRect (MakeWinRect (x1, y1, x2, y2), &scr_rect, A_XOR);
	mode--;
	}while(mode>0);
	SetPlane(DARK_PLANE);
	
}

void GrayLine(int x1, int y1, int x2, int y2, int mode)
{
	do{
	switch(mode)
	{
		case 0: case 2: SetPlane(LIGHT_PLANE); break;
		case 1:  SetPlane(DARK_PLANE);
	}
	DrawLine (x1, y1, x2, y2, A_XOR);
	mode--;
	}while(mode>0);
	SetPlane(DARK_PLANE);
	
}



void CursorSprite16 (short x, short y, unsigned short *sprite, int screen)
{
	
	if(screen==0){
	Sprite16_XOR (x, y, 16, sprite, GetPlane(DARK_PLANE)); 
  Sprite16_XOR (x, y, 16, sprite+16, GetPlane(LIGHT_PLANE));  
	}
	else{
	Sprite16_XOR (x, y, 16, sprite, darkplane); 
  Sprite16_XOR (x, y, 16, sprite+16, lightplane);  
	}
}


//draws a sprite in gray on real or virtual screen: inversed for enemy side
void GraySprite16 (short x, short y, unsigned short *sprite, int screen, int side)
{
	
	if(checkscr(x,y)){
	
	switch(screen)
	{
		case 0:
		switch(side)
		{
			case 0:
			Sprite16_XOR (x-curmapx, y-curmapy, 16, sprite, GetPlane(DARK_PLANE)); 
  		Sprite16_XOR (x-curmapx, y-curmapy, 16, sprite+16, GetPlane(LIGHT_PLANE));  
  		break;
  		case 1:
			Sprite16_XOR (x-curmapx, y-curmapy, 16, sprite+16, GetPlane(DARK_PLANE)); 
  		Sprite16_XOR (x-curmapx, y-curmapy, 16, sprite, GetPlane(LIGHT_PLANE));  
  		break;
  		
  		
		}
		
		case 1:
  	switch(side)
  	{
  		case 0:
  		Sprite16_XOR (x-curmapx, y-curmapy, 16, sprite, darkplane); 
  		Sprite16_XOR (x-curmapx, y-curmapy, 16, sprite+16, lightplane);  
			break;
			case 1:
  		Sprite16_XOR (x-curmapx, y-curmapy, 16, sprite+16, darkplane); 
  		Sprite16_XOR (x-curmapx, y-curmapy, 16, sprite, lightplane);  
			break;
  	}
  		
		
	}
	}
	
}



	

	







void drawhealth(int x, int y, int hp, int maxhp, int width, int store, int maxstore)
	{
		int i;
		if(checkscr(x,y)){
		//PortSet (darkplane, 239, 127);
		if(width>3||width==0) width=1;
		
		DrawLine(x-curmapx,y-curmapy,x+(hp*16*width/maxhp)-curmapx,y-curmapy,A_XOR);
		DrawLine(x-curmapx,y+1-curmapy,x+(hp*16*width/maxhp)-curmapx,y+1-curmapy,A_XOR);		
		
		if(maxstore>0){
		for(i=x;i<=x+maxstore*2+1;i+=2)
		DrawPix(i-curmapx,y-2-curmapy,A_XOR);		
		
		
		if(store>0){
		SetPlane(LIGHT_PLANE);
		DrawLine(x-curmapx,y-2-curmapy,x+store*2-curmapx,y-2-curmapy,A_XOR);		
		DrawLine(x-curmapx,y-1-curmapy,x+store*2-curmapx,y-1-curmapy,A_XOR);		
		SetPlane(DARK_PLANE);
		}
		
		}
		
		}
		
	}




void clrgrayscr()
 	{				
 					SetPlane(LIGHT_PLANE);
 					clrscr();
 					SetPlane(DARK_PLANE);
 					clrscr();
 	}				
 	


int square(int base)
{
	return base*base;
}



int abszero(int x)
 	{
 		if(x<0) return 0;
 		else return x;
 	}


int fogremover(int x, int y,int sight)
{
	int k,l,change=0;
					for(k=0;k<mapheight;k++)
					{
						for(l=0;l<mapwidth;l++)
						{
							if(fog[k][l]==1&&abs(k-y)+abs(l-x)<=sight){
								fog[k][l]=0;
								change=1;
							} 
						}
					}					
				
		if(change==1) return TRUE;
		else return FALSE;
	
}		


void DrawInt(int x, int y, int numer, int size)
{
	char str[10];
	FontSetSys(size);
	sprintf(str,"%d",numer);
	DrawStr(x,y,str,2);
}


int closestbuilding(int x, int y)
{
	int i,j;
	
	for(j=y-4;j<y+4;j++)
	{
		for(i=x-4;i<x+4;i++)
		{
			if(map[j][i]>0&&*(punittypes+*(punits+UNIT_VALUES*map[j][i]+21)*UNITTYPE_VALUES)<4&&*(punits+UNIT_VALUES*map[j][i]+17)==yourside
			&&abs(x-i)+abs(y-j)<4) return TRUE;
		}
	}
	return FALSE;
	
}


int drawbuilding(int x, int y, int width, int height, int pic,int mode, int side, int plane)
{
	int i=0,j,k=0,ok=1;
	
	
	//for turrets
	if(width==0)
	{
	if(map[y/16][x/16]==0&&tmap[y/16][x/16]==0&&closestbuilding(x/16,y/16)==TRUE)  ok=0;
	
	if(ok==0||mode==0){
				  GraySprite16(x,y,pics+pic*32,plane,side);
		
	}
	
	if(ok==0||mode==0)  return TRUE;
	return FALSE;  
	}
	
	
	
	if(mode!=0){
	for(j=0;j<height;j++)
	{
		for(i=0;i<width;i++)
		{
		if((closestbuilding(x/16+i,y/16+j))==TRUE)  ok=0;
		}
	}			
	}
	
	if(ok==0||mode==0){
		
	
	for(j=0;j<height;j++)
	{
		for(i=0;i<width;i++)
		{
			
			if((map[y/16+j][x/16+i]==0&&tmap[y/16+j][x/16+i]==0)||(mode==0))
			{
				  GraySprite16(x+16*i,y+16*j,pics+32*(pic+k),plane,side);
				
			}
			else ok=1;
			
			
			k++;
		}
	}
	}

if(ok==0||mode==0) return TRUE;	
else	return FALSE;

}


//checks buildings for a certain type
int checkforunit(int type, int side, int builder)
{
	int i;
	if(type<0) return TRUE;
	for(i=1;i<MAX_UNITS+MAX_BUILDINGS;i++)
	{
		if(*(punits+UNIT_VALUES*i+21)==type&&*(punits+UNIT_VALUES*i)>=0&&*(punits+UNIT_VALUES*i+17)==side&&(builder<0||builder==2||*(punits+UNIT_VALUES*i+29)==builder))  return TRUE;
	}
	return FALSE;
	
}


int checkline(int x,int max)
{
	if(x<0) return 0;
	if(x>max) return max;
	return x;
}


void fixscreen()
{
	if(curmapx<0) curmapx=0;
	if(curmapy<0) curmapy=0;				
	if(curmapx>mapwidth*16-160)  curmapx=mapwidth*16-160;
	if(curmapy>mapheight*16-100)  curmapy=mapheight*16-100;
};




/////////////////////////////DRAW MAP//////////////////////////////////////
/////////////////////////////DRAW MAP//////////////////////////////////////
/////////////////////////////DRAW MAP//////////////////////////////////////
/////////////////////////////DRAW MAP//////////////////////////////////////


void drawmap()
{
	int i,j,width;
	SCR_RECT rect;
	
	
FastCopyScreen(sidebarl,lightplane);
FastCopyScreen(sidebard,darkplane);

	
	
for(j=0;j<3;j++){	
if(allbuilders[j].oldrow>0&&allbuilders[j].type==inview[j-j/2])
		{
			rect=(SCR_RECT){{1,allbuilders[j].y+1,16,allbuilders[j].oldrow+allbuilders[j].y}};
			PortSet(darkplane,239,127);
			ScrRectFill( &rect, &scr_rect,A_XOR);
			PortSet(lightplane,239,127);
			ScrRectFill( &rect, &scr_rect,A_XOR);
			
		}
if(allbuilders[j].oldrow>0&&allbuilders[j].type!=inview[j-j/2])
	{
			rect=(SCR_RECT){{1,allbuilders[j].y+1,16,allbuilders[j].y+16}};
			PortSet(lightplane,239,127);
			ScrRectFill( &rect, &scr_rect,A_XOR);
	}		
}


	
	
		for(j=abszero(curmapy/16-1);j<curmapy/16+8;j++)
		{
			for(i=abszero(curmapx/16-1);i<curmapx/16+11;i++)
			{
		
							//terrain
			if(map[j][i]<0)
			{							
			GraySprite16(i*16,j*16,pics+32*(NUMBER_OF_UNIT_PICS+(map[j][i]*(-1)-1)),1,0);
			}
		
			//tiberium
			if(tmap[j][i]>0)  {
 			GraySprite16(i*16,j*16,pics+32*(tmap[j][i]+NUMBER_OF_UNIT_PICS),1,0);
 			}

		
			//fog of war
			if(fog[j][i]==1&&i*16>curmapx-16&&i*16<=curmapx+160&&j*16>curmapy-16&&j*16<=curmapy+100)
			  {
			  	
			  	if(i*16<curmapx)
			  	{
			  	rect=(SCR_RECT){{0,abszero(j*16-curmapy),i*16-curmapx+15,j*16-curmapy+15}};
			  	PortSet(darkplane,239,127);
			  	ScrRectFill(&rect,&scr_rect,A_XOR);
			  	//PortSet(lightplane,239,127);
			  	//ScrRectFill(&rect,&scr_rect,A_XOR);
			  	
			  	}
			  	else {
					//Sprite16(j*16-curmapx,i*16-curmapy,16,&cursor[4][16],lightplane,SPRT_XOR);
					Sprite16_XOR(i*16-curmapx,j*16-curmapy,16,cursor+4*32,darkplane);
					}
					
			  }
				  
			  
		
		}
		 
	}
	  
	
	PortSet(darkplane,239,127);
	
	//money
	if(*pmoney>0)
	DrawInt(0,35,*pmoney,0);
	
	  
	//display units on display
	for(i=1;i<MAX_UNITS+MAX_BUILDINGS;i++)
	{
		if(*(punits+UNIT_VALUES*i+8)>0&&checkscr(*(punits+UNIT_VALUES*i+8)-8,*(punits+UNIT_VALUES*i+9)-8)){
				
			if(i<MAX_UNITS){
				GraySprite16(*(punits+UNIT_VALUES*i+8)-8,*(punits+UNIT_VALUES*i+9)-8,pics+32*(*(punittypes+UNITTYPE_VALUES*
				(*(punits+UNIT_VALUES*i+21))+1)+(*(punits+UNIT_VALUES*i+10))/450+*(punits+UNIT_VALUES*i+26)),1,*(punits+UNIT_VALUES*i+17));
			
			
			
			}
			
			
			//storage slots	
			if(*(punittypes+UNITTYPE_VALUES*(*(punits+UNIT_VALUES*i+21))+6)>0&&*(punits+UNIT_VALUES*i+18)==1){
		
		for(j=(*(punits+UNIT_VALUES*i+8))-8;j<=(*(punits+UNIT_VALUES*i+8))-8+2*(*(punittypes+UNITTYPE_VALUES*
				(*(punits+UNIT_VALUES*i+21))+6));j+=2)
		DrawPix(j-curmapx,*(punits+UNIT_VALUES*i+9)-10-curmapy,A_XOR);		
		
		if(*(punits+UNIT_VALUES*i+24)>0){
		PortSet(lightplane,239,127);
		DrawLine(*(punits+UNIT_VALUES*i+8)-8-curmapx,*(punits+UNIT_VALUES*i+9)-10-curmapy,*(punits+UNIT_VALUES*i+8)-8+*(punits+UNIT_VALUES*i+24)*2-curmapx,*(punits+UNIT_VALUES*i+9)-10-curmapy,A_XOR);		
		DrawLine(*(punits+UNIT_VALUES*i+8)-8-curmapx,*(punits+UNIT_VALUES*i+9)-9-curmapy,*(punits+UNIT_VALUES*i+8)-8+*(punits+UNIT_VALUES*i+24)*2-curmapx,*(punits+UNIT_VALUES*i+9)-9-curmapy,A_XOR);		
		PortSet(darkplane,239,127);
		}
		}
			
			//health bars
			if(*(punits+UNIT_VALUES*i+18)==1)
			{
				PortSet(darkplane,239,127);
				width=*(punittypes+UNITTYPE_VALUES*(*(punits+UNIT_VALUES*i+21)));
				if(width>3||width==0) width=1;
				
				DrawLine(*(punits+UNIT_VALUES*i+8)-8-curmapx, *(punits+UNIT_VALUES*i+9)-8-curmapy, *(punits+UNIT_VALUES*i+8)-8+
				((*(punits+UNIT_VALUES*i+23))*16*width/(*(punittypes+UNITTYPE_VALUES*(*(punits+UNIT_VALUES*i+21))+4)))-curmapx,*(punits+UNIT_VALUES*i+9)-8-curmapy,A_XOR);
				
				DrawLine(*(punits+UNIT_VALUES*i+8)-8-curmapx, *(punits+UNIT_VALUES*i+9)-7-curmapy, *(punits+UNIT_VALUES*i+8)-8+
				((*(punits+UNIT_VALUES*i+23))*16*width/(*(punittypes+UNITTYPE_VALUES*(*(punits+UNIT_VALUES*i+21))+4)))-curmapx,*(punits+UNIT_VALUES*i+9)-7-curmapy,A_XOR);
				
			}	
		
		  
		
		
		
			
			
  		//drawhealth(*(punits+UNIT_VALUES*i+8)-8,*(punits+UNIT_VALUES*i+9)-8,*(punits+UNIT_VALUES*i+23),*(punittypes+UNITTYPE_VALUES*(*(punits+UNIT_VALUES*i+21))+4));
			}
			
			
			
			//baddy markers
		if(*(punits+UNIT_VALUES*i+17)!=yourside&&checkscr(*(punits+UNIT_VALUES*i+8)-13,*(punits+UNIT_VALUES*i+9)-5)){
			Sprite8_XOR (*(punits+UNIT_VALUES*i+8)-13-curmapx, *(punits+UNIT_VALUES*i+9)-5-curmapy, 5, baddymark, darkplane);   		
		}

		if(*(punits+UNIT_VALUES*i+8)>0&&*(punittypes+UNITTYPE_VALUES*(*(punits+UNIT_VALUES*i+21))+2)>25&&*(punittypes+UNITTYPE_VALUES*(*(punits+UNIT_VALUES*i+21)))>3
		&&checkscr(*(punits+UNIT_VALUES*i+8)+8,*(punits+UNIT_VALUES*i+9)-5)){
			Sprite8_XOR (*(punits+UNIT_VALUES*i+8)+8-curmapx, *(punits+UNIT_VALUES*i+9)-5-curmapy, 5, icon[*(punittypes+UNITTYPE_VALUES*(*(punits+UNIT_VALUES*i+21))+14)], darkplane);   		
			Sprite8_XOR (*(punits+UNIT_VALUES*i+8)+8-curmapx, *(punits+UNIT_VALUES*i+9)-5-curmapy, 5, &icon[*(punittypes+UNITTYPE_VALUES*(*(punits+UNIT_VALUES*i+21))+14)][5], lightplane);   		
		}
			
				
	}
	
		
	
	//display bullets
	for(i=1;i<MAX_BULLETS;i++)
	{
		
		
		if(*(pbullets+BULLET_VALUES*i)>0&&checkscr(*(pbullets+BULLET_VALUES*i+1)+*(pbullets+BULLET_VALUES*i)*
			(*(pbullets+BULLET_VALUES*i+5))/(*(pbullets+BULLET_VALUES*i+7))-4,*(pbullets+BULLET_VALUES*i+2)+*(pbullets+BULLET_VALUES*i)*
			(*(pbullets+BULLET_VALUES*i+6))/(*(pbullets+BULLET_VALUES*i+7))-4)==TRUE)
			{
				Sprite8_XOR(*(pbullets+BULLET_VALUES*i+1)+*(pbullets+BULLET_VALUES*i)*
			(*(pbullets+BULLET_VALUES*i+5))/(*(pbullets+BULLET_VALUES*i+7))-curmapx-4,*(pbullets+BULLET_VALUES*i+2)+*(pbullets+BULLET_VALUES*i)*
			(*(pbullets+BULLET_VALUES*i+6))/(*(pbullets+BULLET_VALUES*i+7))-curmapy-4,8,shell+16*(*(pbullets+BULLET_VALUES*i+11)),darkplane); 		
			
				Sprite8_XOR(*(pbullets+BULLET_VALUES*i+1)+*(pbullets+BULLET_VALUES*i)*
			(*(pbullets+BULLET_VALUES*i+5))/(*(pbullets+BULLET_VALUES*i+7))-curmapx-4,*(pbullets+BULLET_VALUES*i+2)+*(pbullets+BULLET_VALUES*i)*
			(*(pbullets+BULLET_VALUES*i+6))/(*(pbullets+BULLET_VALUES*i+7))-curmapy-4,8,shell+16*(*(pbullets+BULLET_VALUES*i+11))+8,lightplane); 		
			
			} 
	}


	
	//explosions
  	for(j=0;j<MAX_EXPLOSIONS;j++)
  	{
  	
  	if(*(pexplosions+4*j+3)>=1000&&*(pexplosions+4*j)>0)
  	DrawLine(checkline(((*(pexplosions+4*j+3)-1000)-(*(pexplosions+4*j+3)-1000)/100*100)*16+8-curmapx,159),
				checkline((*(pexplosions+4*j+3)-1000)/100*16-curmapy,99),checkline(*(pexplosions+4*j+1)-curmapx,159)
				,checkline(*(pexplosions+4*j+2)-curmapy,99),A_XOR);

  	
  	
  	if(*(pexplosions+4*j+3)<1000&&*(pexplosions+4*j)>0&&checkscr(*(pexplosions+4*j+1),*(pexplosions+4*j+2))==TRUE)
  	{
  		GraySprite16(*(pexplosions+4*j+1),*(pexplosions+4*j+2),
  		explode+32*(*(pexplosions+4*j+3)),1,0);
  		
  	}
  	//GraySprite16(*(pexplosions+4*j+1),*(pexplosions+4*j+2),&explode[*(pexplosions+4*j+3)][0]);
  	
  	}
  
  
  //flares
  for(i=0;i<3;i++)
  {
  	if(flares[i][0]>=0)
  	GraySprite16(flares[i][0]*16,flares[i][1]*16,flare,1,0);
  }
  
	
	
 
	
	
	for(i=MAX_UNITS;i<MAX_BUILDINGS+MAX_UNITS;i++)
	{
		if(*(punits+UNIT_VALUES*i)>=0)
		{
		
			drawbuilding(*(punits+UNIT_VALUES*i)*16,*(punits+UNIT_VALUES*i+1)*16,
			*(punittypes+UNITTYPE_VALUES*(*(punits+UNIT_VALUES*i+21))),*(punittypes+UNITTYPE_VALUES*(*(punits+UNIT_VALUES*i+21))+2),*(punittypes+UNITTYPE_VALUES*
				(*(punits+UNIT_VALUES*i+21))+1),0,*(punits+UNIT_VALUES*i+17),1);
		}
	
		
		/*if(*(pbuilding*(i-MAX_UNITS))*16>=curmapx&&*(pbuilding*(i-MAX_UNITS))*16<curmapx+160&&
		*(pbuilding*(i-MAX_UNITS)+1)*16>=curmapy-16&&*(pbuilding*(i-MAX_UNITS)+1)*16<curmapy+100)
		{
			GraySprite16(*(punits+24*MAX_UNITS)*16,*(punits+24*MAX_UNITS+1)*16,buildingpics[0]);		
			GraySprite16(*(punits+24*MAX_UNITS)*16+16,*(punits+24*MAX_UNITS+1)*16,buildingpics[1]);		
			GraySprite16(*(punits+24*MAX_UNITS)*16,*(punits+24*MAX_UNITS+1)*16+16,buildingpics[2]);		
			GraySprite16(*(punits+24*MAX_UNITS)*16+16,*(punits+24*MAX_UNITS+1)*16+16,buildingpics[3]);		
			
		}*/
			
	}
	
	
	PortSet (lightplane, 239, 127);
	
  		
  //select box	
  if(*pselectbox>=0)
  DrawClipRect(MakeWinRect(*(pselectbox)-curmapx,*(pselectbox+1)-curmapy,*(pselectbox+2)-curmapx,*(pselectbox+3)-curmapy),&scr_rect,A_XOR);
			
  	
  //box on minimap
  if(poweroutput>powerconsumption&&checkforunit(COMM,yourside,-1)){		
	DrawClipRect (MakeWinRect ((curmapx/16)/(mapwidth/33+1), (curmapy/16)/(mapheight/33+1), ((curmapx+160-16)/16)/(mapwidth/33+1), ((curmapy+100-16)/16)/(mapheight/33+1)),
	 &scr_rect, A_XOR);
	 }
	 
	
	
	if(checkforunit(YARD,yourside,-1)){
	//current bulding built
	CursorSprite16(1,51,pics+32*(*(punittypes+UNITTYPE_VALUES*inview[0]+1)),1);
	
	}
	
	if((checkforunit(WEAP,yourside,-1)||checkforunit(PYLE,yourside,-1))){
	//current unit built
	CursorSprite16(1,71,pics+32*(*(punittypes+UNITTYPE_VALUES*inview[1]+1)+4),1);
	}
	
	
	//warning on minimap
	if(*pwarning>1&&poweroutput>powerconsumption&&checkforunit(COMM,yourside,-1)){
	PortSet(darkplane,239,127);
	DrawClipRect(MakeWinRect (*(pwarning+2)-*(pwarning)/2,*(pwarning+3)-*(pwarning)/2,
						*(pwarning+2)+*(pwarning)/2,*(pwarning+3)+*(pwarning)/2), &scr_rect, A_XOR);		
	}
	
	
FastCopyScreen(lightplane,GetPlane(LIGHT_PLANE));
FastCopyScreen(darkplane,GetPlane(DARK_PLANE));
	
	
	
	
	SetPlane(DARK_PLANE);	
	
	
}










int getnum(void)
{
	int num;
	num=(ngetchx()-48)*10;
	num+=ngetchx()-48;
	return num;
}


int checkforeven(int num)
  {
  	int i;
  	i=num*5;
  	i=i-(num/2*10);
  	if(i==0) return TRUE;
  	return FALSE;
  	
  };
  

//search for closest tiberium or unit if a certain type or side
int closestsearch(int *x,int *y,int side,int type)
{
	int i,j,r;
	
	
	
	
	
		
	if(random(2)==0||side>=0){
	for(r=1;r<mapheight;r++)
	{
		for(j=*(y)-r;j<=*(y)+r;j++)
		{
			i=*(x)-r;
			while(i<=*(x)+r)
			{
					if(j>=0&&j<mapheight&&i>=0&&i<mapwidth){
					if(side<0)
					{
	
					if(tmap[j][i]>0&&map[j][i]==0)
					{
						*x=i;
						*y=j;
						return TRUE;
					}
					}
					//unit
					else
					{
						if((map[j][i]>0)&&((type>=0&&*(punits+map[j][i]*UNIT_VALUES+21)==type)||(type==-1&&map[j][i]<MAX_UNITS)||(type<-1&&map[j][i]>=MAX_UNITS))&&*(punits+map[j][i]*UNIT_VALUES+17)==side)
						{
							*x=i;
							*y=j;
							//for refinery
							if(type==PROC)  *y=*(punits+map[j][i]*UNIT_VALUES+1)+3;
							return TRUE;
						}
					}
					}
				
				if(j==*(y)-r||j==*(y)+r) i++;
				else i+=2*r;
			}
		}
	}
	}
	else
	{
		for(r=1;r<mapheight;r++)
	{
		for(j=*(y)+r;j>=*(y)-r;j--)
		{
			i=*(x)+r;
			while(i>=*(x)-r)
			{
				if(j>=0&&j<mapheight&&i>=0&&i<mapwidth){
					
				if(side<0){
				if(tmap[j][i]>0&&map[j][i]==0)
					{
						*x=i;
						*y=j;
						return TRUE;
					}
					}
					}
					
				if(j==*(y)-r||j==*(y)+r) i--;
				else i-=2*r;
			}
		}
	}	
	}
	
	return FALSE;
	
}



//SEARCH FOR NEXT UNIT IN BUILD QUE
int searchfornext(int start, int direction, int mode)
{				
	int i;
	for(i=start+direction;i<NUMBER_OF_TYPES_OF_UNITS&&i>0;i+=direction)
	{
		//buildings
		if(mode==0&&
		*(punittypes+UNITTYPE_VALUES*i)<4&&checkforunit(*(punittypes+UNITTYPE_VALUES*i+9),yourside,*(punittypes+UNITTYPE_VALUES*i+12))&&
		checkforunit(*(punittypes+UNITTYPE_VALUES*i+10),yourside,-1)&&techlevel>=*(punittypes+UNITTYPE_VALUES*i+13)) return i;
		
		//units
		if(mode==1&&
		*(punittypes+UNITTYPE_VALUES*i)>=4&&checkforunit(*(punittypes+UNITTYPE_VALUES*i+9),yourside,*(punittypes+UNITTYPE_VALUES*i+12))&&
		checkforunit(*(punittypes+UNITTYPE_VALUES*i+10),yourside,-1)&&techlevel>=*(punittypes+UNITTYPE_VALUES*i+13)) return i;
	}
	
	
	return start;
	
}				


//select a team based on number pushed
void selectgroup(int teamnum,int *curset,int oldcurset, int oldcol, int oldrow)
{
	int j=0,mapnum;
	
	//unselect units that are selected
	for(mapnum=1;mapnum<MAX_UNITS+MAX_BUILDINGS;mapnum++)
	{
	
	if(*(punits+mapnum*UNIT_VALUES+18)==1&&*(punits+mapnum*UNIT_VALUES+25)==teamnum&&j==0)
	{
	curmapx=*(punits+mapnum*UNIT_VALUES+8)-80;
	curmapy=*(punits+mapnum*UNIT_VALUES+9)-50;
	if(curmapx<0)  curmapx=0;
	if(curmapy<0)  curmapy=0;
	if(curmapx>mapwidth*16-160)  curmapx=mapwidth*16-160;
	if(curmapy>mapheight*16-100)  curmapy=mapheight*16-160;
	
	
	drawmap();
	if(oldcurset<50)  CursorSprite16(oldcol,oldrow,cursor+oldcurset*32,0);
	if(oldcurset==50)	
		drawbuilding((oldcol+curmapx+8)/16*16,(oldrow+curmapy+8)/16*16,*(punittypes+allbuilders[0].type*UNITTYPE_VALUES),
	*(punittypes+UNITTYPE_VALUES*allbuilders[0].type+2),*(punittypes+UNITTYPE_VALUES*allbuilders[0].type+1),1,yourside,0);
	
	j=1;
	}
	
	if(*(punits+mapnum*UNIT_VALUES+18)==1){
	drawhealth(*(punits+mapnum*UNIT_VALUES+8)-8,*(punits+mapnum*UNIT_VALUES+9)-8,*(punits+mapnum*UNIT_VALUES+23),
	*(punittypes+*(punits+mapnum*UNIT_VALUES+21)*UNITTYPE_VALUES+4),*(punittypes+*(punits+mapnum*UNIT_VALUES+21)*UNITTYPE_VALUES),*(punits+mapnum*UNIT_VALUES+24),*(punittypes+*(punits+mapnum*UNIT_VALUES+21)*UNITTYPE_VALUES+6));	
	
	*(punits+mapnum*UNIT_VALUES+18)=0;
	}
	
	
	}
	

	for(mapnum=1;mapnum<MAX_UNITS;mapnum++)
	{
		if(*(punits+mapnum*UNIT_VALUES+25)==teamnum&&*(punits+mapnum*UNIT_VALUES+17)==yourside)
		{ 
		 *(punits+mapnum*UNIT_VALUES+18)=1;
		drawhealth(*(punits+mapnum*UNIT_VALUES+8)-8,*(punits+mapnum*UNIT_VALUES+9)-8,*(punits+mapnum*UNIT_VALUES+23),
	*(punittypes+*(punits+mapnum*UNIT_VALUES+21)*UNITTYPE_VALUES+4),*(punittypes+*(punits+mapnum*UNIT_VALUES+21)*UNITTYPE_VALUES),*(punits+mapnum*UNIT_VALUES+24),*(punittypes+*(punits+mapnum*UNIT_VALUES+21)*UNITTYPE_VALUES+6));	
	
		*curset=2;
		}
	}
	
	
};



int totaldamage(int damage, int damagetype, int armortype)
{
	
	switch(damagetype)
	{
		case 1:	//tank fire
		switch(armortype)
		{
			case 0:	damage*=4; break;//no armor
			case 1:	damage*=8; break;//light armor
			case 2:	damage*=10; break;//heavy armor
			case 3:	damage*=8; break;//wood armor ; buildings
		}
		break;
		
		case 0:	//small arms fire
		switch(armortype)
		{
			case 0:	damage*=10; break;//no armor
			case 1:	damage*=7; break;//light armor
			case 2:	damage*=2; break;//heavy armor
			case 3:	damage*=6; break;//wood armor ; buildings
		}
		break;
		
		case 2:	//flame
		switch(armortype)
		{
			case 0:	damage*=9; break;//no armor
			case 1:	damage*=6; break;//light armor
			case 2:	damage*=2; break;//heavy armor
			case 3:	damage*=10; break;//wood armor ; buildings
		}
		break;
		
		case 3:	//high explosive
		switch(armortype)
		{
			case 0:	damage*=8; break;//no armor
			case 1:	damage*=10; break;//light armor
			case 2:	damage*=6; break;//heavy armor
			case 3:	damage*=9; break;//wood armor ; buildings
		}
		break;
		
		case 4:	//super
		switch(armortype)
		{
			case 0:	damage*=10; break;//no armor
			case 1:	damage*=10; break;//light armor
			case 2:	damage*=10; break;//heavy armor
			case 3:	damage*=10; break;//wood armor ; buildings
		}
		break;
		
		case 5:	//SNIPE
		switch(armortype)
		{
			case 0:	damage*=10; break;//no armor
			case 1:	damage*=1; break;//light armor
			case 2:	damage*=1; break;//heavy armor
			case 3:	damage*=1; break;//wood armor ; buildings
		}
		break;
		
	}
	
	
	return damage/10;
}



void creatingunit(int i/*number*/, int row, int col, int direction, int side, int type, int hp)
{  
 	
 	*(punits+i*UNIT_VALUES)=col;
 	*(punits+i*UNIT_VALUES+1)=row;
 	*(punits+i*UNIT_VALUES+10)=direction;
 	*(punits+i*UNIT_VALUES+17)=side;
 	*(punits+i*UNIT_VALUES+21)=type;	
 	*(punits+i*UNIT_VALUES+23)=hp;
 	
  *(punits+i*UNIT_VALUES+8)=col*16+8;
 	*(punits+i*UNIT_VALUES+9)=row*16+8;
 	*(punits+i*UNIT_VALUES+2)=col;
 	*(punits+i*UNIT_VALUES+3)=row;
 	//*(punits+i*UNIT_VALUES)=col;
 	*(punits+i*UNIT_VALUES+14)=direction;
 	*(punits+i*UNIT_VALUES+13)=direction;
 	*(punits+i*UNIT_VALUES+11)=col*16+8;
 	*(punits+i*UNIT_VALUES+12)=row*16+8;
 	*(punits+i*UNIT_VALUES+4)=col;
 	*(punits+i*UNIT_VALUES+5)=row;
 	*(punits+i*UNIT_VALUES+6)=col;
 	*(punits+i*UNIT_VALUES+7)=row;
 	*(punits+i*UNIT_VALUES+15)=100;
 	*(punits+i*UNIT_VALUES+18)=0;
 	*(punits+i*UNIT_VALUES+19)=MOVE;
 	*(punits+i*UNIT_VALUES+20)=1;
 	*(punits+i*UNIT_VALUES+24)=0;
 	*(punits+i*UNIT_VALUES+25)=0; 
 	*(punits+i*UNIT_VALUES+28)=0; 
 	*(punits+i*UNIT_VALUES+27)=0; 
 	*(punits+i*UNIT_VALUES+26)=0; 
 	*(punits+i*UNIT_VALUES+29)=side; 
 	
 		
}



void InputStr (int x, int y, char *buffer, int maxlen)
{
  SCR_STATE ss;
  int key, i = strlen(buffer);
  char name[8];
  buffer[i] = 0;
  SaveScrState (&ss);
  do
    {
      MoveTo (ss.CurX, ss.CurY);
      sprintf (name,"%s_  ", buffer);
      DrawStr(x,y,name,4);
        // Note that two spaces are required if F_4x6 font is used
      key = ngetchx ();
      if (key >= ' ' && key <= '~' && i < maxlen) buffer[i++] = key;
      if (key == KEY_BACKSPACE && i) i--;
      buffer[i] = 0;
    } while (key != KEY_ENTER);
    
}
	

void endgame()
{ 		
	PortRestore();
	
	
	memset(GetPlane(LIGHT_PLANE),0,3840);
	memset(GetPlane(DARK_PLANE),0,3840);
	memset(LCD_MEM,0,LCD_SIZE);
	
	
	poke(0x600017,0xB2);      // Restore normal timer speed
	
	GrayOff();
	
	
	free(lightplane);
	free(darkplane);
	free(sidebarl);
	free(sidebard);
	free(map);
	free(fog);
	free(tmap);
	free(allbullets);
	free(allexplosions);	
	free(allunits);
	
	
SetIntVec (AUTO_INT_1, save_int_1);
	
FontSetSys(1);


}


int divisible(int num, int x)
{
	if((floor(num/x)*x)==num)
	return TRUE;
	return FALSE;	
}



//fills map where building is
void placebuilding(int i)	//unit number
{
	int j,k;
		
				for(j=allunits[i].row;j<allunits[i].row+(*(punittypes+UNITTYPE_VALUES*allunits[i].type+2));j++)
  		{
  			for(k=allunits[i].col;k<allunits[i].col+(*(punittypes+UNITTYPE_VALUES*allunits[i].type));k++)
  			{
					  		map[j][k]=i;
  			}
  		}
  		//repair bay
					  		if(allunits[i].type==BAY)
					  		{
					  			map[allunits[i].row][allunits[i].col+1]=0;
					  			map[allunits[i].row+1][allunits[i].col]=0;
					  			map[allunits[i].row+1][allunits[i].col+2]=0;
					  			
					  		}

}

	

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////MAIN FUNCTION/////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

// Main Function
void _main(void)
{
	
	int row=45,col=80,oldrow=45,oldcol=80,key,curset=0,oldcurset=0,second_hold=0,temp,temp1,mapnum=0,i,j,k,l,m,n,
	unitnum=0,diamond_hold=0,bulletnum=0,arrow=0,arrowx=0,arrowy=0,scrollspeed=5,gamespeed=245,
	tiberiumgrowthtimer=0,killdead=0,exit=0;
	

	int redraw=0;
	int mousespeed=2;	//speed of the mouse
	
	
	float side_a=0,side_b=0;

	char moveorder[10];

	int enemybuilder[4]= {};//building currently, finish, units
	
	int enemybuildque[3]={0,0,0};//number of,type row in teams,col in teams
	
	int money=0,enemymoney=0;
	
	//buildings enemy will build or rebuild if destroyed
	int enemytobuild[MAX_TOBUILDS][3]={{}};	//x,y,type


char TIOSname[12];
HSym hsym;
		
	
int teams[10][11]={{}};

int order[50][3]={{}};


int triggers[MAX_TRIGGERS][6]={{}};

	int allowvictory=1;
	
	
	int maxtiberium=0,currenttiberium=0;	//how much tiberium can you hold?
	
	int warning[4]= {0,0,5,3};  //{size,timer,x,y}
	
	int selectbox[4]= {};  //x1,y1,x2,y2
	

int gametimer=0;	
	
	char savename[10]="ctc2save";
	
	
	//ion cannon and nuke
	int superweapons[2]={0,0};
	

	unsigned int keyer=0;
	
	
	char unitnames[NUMBER_OF_TYPES_OF_UNITS][12]=
	{
		"CONST YARD",
		"POWER PLANT",
		"ADV POWER",
		"GUARD TOWER",
		"ADV TOWER",
		"TURRET",
		"OBELISK",
		"BARRACKS",
		"WAR FACT",
		"REPAIR BAY",
		"SILO",
		"REFINERY",
		"COMM CENTER",
		"MINI GUNNER",
		"GRENADIERS",
		"FLAMETHROWR",
		"ROCKET MEN",
		"ENGINEER",
		"HUMM VEE",
		"RECON BIKE",
		"LIGHT TANK",
		"MED TANK",
		"FLAME TANK",
		"ARTILLERY",
		"MAMMOTH TNK",
		"R LAUNCHER",
		"HARVESTER",
		"MCV",			
		"COMMANDO",			
		"ADV COMM",			
		"NOD TEMPLE",			
		"TECH CENTER",			
		"SCIENTIST",		
		"SCOUT"		
	};
	
	struct unittype allunittypes[NUMBER_OF_TYPES_OF_UNITS]=
	{
	
	//speed,pic,rotate,weapon,hp,sight,store,cost,power,pre1,pre2,armor,side,techlevel, infantry icon
	
		{3,4,2,0,400,4,0,5000,0,-1,-1,3,2,0,0}, //const yard
		{2,0,2,0,150,4,0,300,0,YARD,-1,3,2,1,0}, //power plant
		{2,44,2,0,220,4,0,500,0,YARD,NUKE,3,2,7,0}, //adv power plant
		{0,72+NUMBER_OF_BUILDING_PICS,72,9,100,5,0,500,0,YARD,PYLE,3,0,4,-1}, //guard tower
		{0,73+NUMBER_OF_BUILDING_PICS,72,10,170,5,0,1000,2,YARD,COMM,2,0,7,-1}, //advanced guard tower
		{0,32+NUMBER_OF_BUILDING_PICS,12,4,150,4,0,600,2,YARD,PYLE,2,1,4,0}, //turret
		{0,82+NUMBER_OF_BUILDING_PICS,72,12,180,5,0,1500,15,YARD,COMM,2,1,7,-1}, //obelisk of light
		{2,32,2,0,250,4,0,300,1,YARD,NUKE,3,2,1,0}, //barracks
		{3,10,3,0,300,4,0,2000,3,YARD,PROC,3,2,3,0}, //weapon fact
		{3,38,2,0,300,4,0,1200,3,YARD,WEAP,3,2,6,0}, //repair bay
		{2,36,1,0,100,4,15,150,1,YARD,PROC,3,2,2,0}, //silo
		{3,19,3,0,300,4,23,2000,4,YARD,NUKE,3,2,2,0}, //refinery
		{2,28,2,0,250,5,0,1000,4,YARD,PROC,3,2,3,0}, //comm center
		{11,24+NUMBER_OF_BUILDING_PICS,36,2,30,3,0,200,0,PYLE,-1,0,2,1,0}, //minigunners
		{11,56+NUMBER_OF_BUILDING_PICS,36,7,35,3,0,300,0,PYLE,-1,0,0,2,1}, //grenadier
		{11,107+NUMBER_OF_BUILDING_PICS,36,15,30,3,0,350,0,PYLE,-1,0,1,2,2}, //FLAME THORWER
		{14,48+NUMBER_OF_BUILDING_PICS,36,6,25,3,0,500,0,PYLE,-1,0,2,3,3}, //rocket men
		{14,115+NUMBER_OF_BUILDING_PICS,36,1,15,3,0,500,0,PYLE,-1,0,2,4,5}, //engineer
		{7,83+NUMBER_OF_BUILDING_PICS,14,13,55,4,0,300,0,WEAP,-1,1,2,3,0}, //humm vee
		{5,64+NUMBER_OF_BUILDING_PICS,18,8,30,5,0,500,0,WEAP,-1,1,1,3,0}, //recon bike
		{8,0+NUMBER_OF_BUILDING_PICS,10,3,70,5,0,600,0,WEAP,-1,2,1,5,0}, //light tank
		{11,8+NUMBER_OF_BUILDING_PICS,8,0,100,4,0,800,0,WEAP,-1,2,0,5,0}, //med tank
		{10,40+NUMBER_OF_BUILDING_PICS,10,5,90,5,0,800,0,WEAP,-1,2,1,6,0}, //flame tank
		{17,74+NUMBER_OF_BUILDING_PICS,6,11,40,4,0,500,0,WEAP,-1,1,1,6,0}, //artiller
		{14,91+NUMBER_OF_BUILDING_PICS,7,14,200,4,0,1500,0,WEAP,BAY,2,0,8,0}, //mammoth
		{10,99+NUMBER_OF_BUILDING_PICS,10,10,60,4,0,1000,0,WEAP,COMM,1,0,8,0}, //ROCKET LAUNCHER
		{14,16+NUMBER_OF_BUILDING_PICS,7,1,160,4,7,1400,0,WEAP,PROC,2,2,3,0}, //harvester
		{14,123+NUMBER_OF_BUILDING_PICS,7,1,200,4,0,2500,0,WEAP,BAY,2,2,10,0}, //MCV
		{11,131+NUMBER_OF_BUILDING_PICS,50,16,35,5,0,1000,0,PYLE,WEAP,0,2,11,4}, //commando
		{2,48,2,0,220,5,0,2800,20,YARD,COMM,3,0,9,0}, //adv comm center
		{3,52,3,0,400,5,0,3000,20,YARD,COMM,3,1,9,0}, //temple of nod
		{3,61,2,0,150,4,0,3000,0,YARD,-1,3,3,12,0}, //technology center
		{14,139+NUMBER_OF_BUILDING_PICS,20,1,8,0,0,500,0,PYLE,-1,0,3,12,0}, //scientist
		{4,139+NUMBER_OF_BUILDING_PICS,20,1,400,80,0,500,0,PYLE,-1,0,3,12,0} //scout
		
	};
	struct warhead allwarheads[17]=
	{
		
		{200,80,10,72,12,3,0,2,1},  // med tank fire
		{400,0,0,0,0,0,0,0,0},  //harvester/engineer
		{130,40,5,300,6,1,1,4,0},  //rifle
		{160,75,8,72,10,2,0,2,1},  // light tank fire
		{200,95,12,72,13,3,0,2,1},  // turret fire
		{160,40,20,42,35,2,0,6,2},  // fire
		{200,70,10,72,12,2,2,8,1},  // tri-rocket
		{200,55,10,42,15,3,1,8,3},  // grenades
		{167,70,7,58,12,2,10,2,1},  // one-rocket
		{167,60,10,300,9,1,1,4,0},  //tower fire
		{167,110,18,58,25,6,10,0,3},  //adv tower rocket
		{320,130,25,42,25,10,0,0,3},  // artillery shell
		{640,130,90,1500,10,0,1,2,4},  // obelisk laser
		{130,55,4,300,6,1,1,4,0},  //humm-vee gun
		{225,90,20,72,16,4,18,8,1},  // dual tank fire
		{167,30,15,42,25,2,0,6,2},  // flame thrower fire
		{200,80,18,400,6,0,1,4,5}  //commando
		
		
	};
	
	
	
	
	
unsigned char str;

int ministart=0;

LCD_BUFFER buffer;
	
	FILE *f;


  LCD_save (buffer);


	
		//pointer to picture data		
		pics=((unsigned short*)HeapDeref(SymFindPtr($(ctc2gfx),0)->handle))+1+NUMBER_OF_SUPER_PICS*32
		+NUMBER_OF_EXPLOSION_PICS*32+NUMBER_OF_CURSOR_PICS*32+NUMBER_OF_BULLET_PICS*8;

		cursor=((unsigned short*)HeapDeref(SymFindPtr($(ctc2gfx),0)->handle))+1+NUMBER_OF_SUPER_PICS*32
		+NUMBER_OF_EXPLOSION_PICS*32+NUMBER_OF_BULLET_PICS*8;

		explode=((unsigned short*)HeapDeref(SymFindPtr($(ctc2gfx),0)->handle))+1+NUMBER_OF_SUPER_PICS*32
		+NUMBER_OF_BULLET_PICS*8;

		superpics=((unsigned short*)HeapDeref(SymFindPtr($(ctc2gfx),0)->handle))+1+NUMBER_OF_BULLET_PICS*8;

		shell=((unsigned char*)HeapDeref(SymFindPtr($(ctc2gfx),0)->handle))+2;




		scr_rect=(SCR_RECT){{0, 0, 159, 99}};

		
		ClrScr();

		
				
		

		FontSetSys(2);	
	
		DrawStr(40,0,"CTC2 v1.00",2);
		FontSetSys(1);	
	
		DrawStr(44,15,"By Ty Taylor",2);
		DrawStr(32,24,"tnt@calcware.org",2);
		
		DrawStr(23,40,"F1 - Resume Saved",2);
		DrawStr(23,50,"F2 - Start New Game",2);
		DrawStr(23,60,"F3 - Custom Level",2);
		DrawStr(23,70,"F4 - Custom Save",2);
		
		
		FontSetSys(0);		
		DrawStr(80,83,"2nd - Select",2);
		DrawStr(80,89,"DIAMOND - Cancel",2);
		DrawStr(0,83,"F1 - Build Building",2);
		DrawStr(0,89,"F2 - Build Unit",2);
		DrawStr(0,95,"SHIFT+COS - Exit",2);
		FontSetSys(1);	
		
		
		while((j=ngetchx())!=KEY_F1&&j!=KEY_F2&&j!=KEY_F3&&j!=KEY_F4&&j!=KEY_ESC);
		
		
		clrscr();
		
		if(j==KEY_ESC)
		{
		 LCD_restore (buffer);
		 return;
		}
		
		
		if(j==KEY_F4)
		{
			savename[0]=0;
			DrawStr(47,30,"SAVE NAME?",2);
			InputStr(55,50,savename,8);
			clrscr();
		}
		
		if(j==KEY_F3)
		{
			DrawStr(47,30,"LEVEL NAME?",2);
			InputStr(55,50,levelname,8);
			clrscr();
		}
		
		
		if(j==KEY_F2){
	
		
		DrawStr(23,40,"F1 - GDI LEVEL",2);
		DrawStr(23,60,"F2 - NOD LEVEL",2);
		while((i=ngetchx()))
		{
			if(i==KEY_F1)
			{
				sprintf(levelname,"ctcg01");		
				break;
			}
			if(i==KEY_F2)
			{
				sprintf(levelname,"ctcn01");		
				break;
			}  
		}
		}



		allunits = calloc (MAX_UNITS+MAX_BUILDINGS, sizeof(*allunits)); 
		allexplosions = calloc (MAX_EXPLOSIONS, sizeof(*allexplosions)); 
		allbullets = calloc (MAX_BULLETS, sizeof(*allbullets));
		map = calloc (MAXWIDTH, sizeof(*map));
		fog = calloc (MAXWIDTH, sizeof(*fog));
		tmap = calloc (MAXWIDTH, sizeof(*tmap));
		lightplane = malloc (LCD_SIZE);  // Allocate the buffer
		darkplane = malloc (LCD_SIZE);  // Allocate the buffer
		sidebarl = malloc (LCD_SIZE);  // Allocate the buffer
		sidebard = malloc (LCD_SIZE);  // Allocate the buffer



save_int_1 = GetIntVec (AUTO_INT_1);
SetIntVec (AUTO_INT_1, DUMMY_HANDLER);   // redirect auto-int 1 to "nothing"
		
		
		//map = calloc (mapwidth*mapheight, sizeof (*map));
		//map = calloc (mapheight, sizeof (*map));
		

		
		//title screen
		
		
		
	FontSetSys(0);	
		
		
		
	
	
		
	
	//for(i=0;i<3840;i++)
	//{
	//	darkplane[i]=0;
	//	lightplane[i]=0;	
	//}

		
		//pointer to unit structure
		punits=&allunits[0].col;
		punittypes=&allunittypes[0].speed;
		pbullets=&allbullets[0].on;
		pexplosions=&allexplosions[0].time;
		pmoney=&money;
		
		//set fog pointer
		
		//set box pointer
		pselectbox=&selectbox[0];
		
		pwarning=&warning[0];
		
		
		
		
		GrayOn(); 
		poke(0x600017,gamespeed);      // Force timer to work faster
	
		
		
	OSFreeTimer(6);
	
	clrgrayscr();	
  
  
 
 	if((j==KEY_F1||j==KEY_F4)&&(f=fopen(savename,"rb"))){
	
	
  for(i=0;i<MAX_UNITS+MAX_BUILDINGS;i++)
  {
  	allunits[i].x=-1;
  	allunits[i].col=-1;
		allunits[i].repair=0;
  }	
	
	fread(&k,2,1,f);
	fread(&allunits[0].col,2,UNIT_VALUES*k,f);

	fread(&k,2,1,f);
	fread(&allunits[MAX_UNITS].col,2,UNIT_VALUES*k,f);
	
	
	//put units on map
	for(i=0;i<MAX_UNITS+MAX_BUILDINGS;i++)
	{
		if(allunits[i].x>0)
		{
			if(i<MAX_UNITS)
			map[allunits[i].row][allunits[i].col]=i;

			else
			{
			placebuilding(i);
  		
  		}
  		
			
		}
	}
	


	
	fread(&allbullets[0].on,2,BULLET_VALUES*MAX_BULLETS,f);
	fread(&allexplosions[0].time,2,4*MAX_EXPLOSIONS,f);
	fread(&levelname,1,10,f);
	fread(&curmapx,2,1,f);
	fread(&curmapy,2,1,f);
	fread(&mapwidth,2,1,f);
	fread(&mapheight,2,1,f);
	fread(&allbuilders[0].y,2,5*3,f);



fread(&k,2,1,f);
for(;k>0;k--)
{
	fread(&i,2,1,f);
	fread(&moveorder[0],1,1,f);
	map[i/100][i-i/100*100]=moveorder[0];
}

fread(&k,2,1,f);
for(;k>0;k--)
{
	fread(&i,2,1,f);
	fread(&tmap[i/100][i-i/100*100],1,1,f);
}


	
	
	for(j=0;j<mapheight;j++){
	fread(&fog[j][0],1,mapwidth,f);
	}


	
	fread(&yourside,2,1,f);
	fread(&enemyside,2,1,f);
	fread(&money,2,1,f);
	fread(&powerconsumption,2,1,f);
	fread(&poweroutput,2,1,f);
	fread(&enemymoney,2,1,f);
	fread(&enemypowerconsumption,2,1,f);
	fread(&enemypoweroutput,2,1,f);
	fread(&row,2,1,f);
	fread(&col,2,1,f);
	fread(&oldrow,2,1,f);
	fread(&oldcol,2,1,f);
	fread(&curset,2,1,f);
	fread(&oldcurset,2,1,f);
	fread(&scrollspeed,2,1,f);
	fread(&gamespeed,2,1,f);
	fread(&tiberiumgrowthtimer,2,1,f);
	fread(&enemybuilder[0],2,4,f);
	fread(&enemybuildque,2,3,f);
	fread(&teams[0][0],2,10*11,f);
	fread(&order[0][0],2,50*3,f);
	fread(&triggers[0][0],2,MAX_TRIGGERS*6,f);
	fread(&maxtiberium,2,1,f);
	fread(&currenttiberium,2,1,f);
	fread(&warning,2,4,f);
	fread(&selectbox,2,4,f);
	fread(&enemytobuild[0][0],2,MAX_TOBUILDS*3,f);
	fread(&techlevel,2,1,f);
	fread(&allowvictory,2,1,f);
	fread(&allmessages,2,6,f);
	fread(&superweapons,2,2,f);
	fread(&inview,2,2,f);
	fread(&mousespeed,2,1,f);
	fread(&gametimer,2,1,f);

	
	fclose(f);	
	}
 	else{
 	
 	startover:
 	
//clear all variables 	
inview[0]=1;
inview[1]=13;
powerconsumption=0;
poweroutput=0;
enemypowerconsumption=0;
enemypoweroutput=0;
memset(enemybuilder,0,2*4);
memset(enemybuildque,0,2*3);
memset(enemytobuild,0,2*MAX_TOBUILDS*3);
memset(teams,0,2*10*11);
memset(order,0,2*50*3);
memset(triggers,0,2*MAX_TRIGGERS*6);
allowvictory=1;
maxtiberium=0;
currenttiberium=0;
superweapons[0]=0;
superweapons[1]=0;
ministart=0;

 	
memset(&allbuilders[0].y,0,2*3*5);

allbuilders[0].y=50;
allbuilders[1].y=70;
allbuilders[2].y=70;

gametimer=0;


 	for(i=0;i<MAX_BULLETS;i++)
  {
  	allbullets[i].on=0;
  	allexplosions[i].time=0;
  }
  
  
  for(i=0;i<MAX_UNITS+MAX_BUILDINGS;i++)
  {
  	allunits[i].x=-1;
  	allunits[i].col=-1;
		allunits[i].repair=0;
  }
 
 		for(i=0;i<MAXHEIGHT;i++)
	{
		for(j=0;j<MAXWIDTH;j++)
		{
			tmap[i][j]=0;
			fog[i][j]=1;
			map[i][j]=0;
		}
	}
	
exit=0;
 	
 	
 	if(!(f=fopen(levelname,"rb")))
 	{
 	endgame();
DrawStr(20,40,"Level not found",A_XOR);
	ngetchx();
			 LCD_restore (buffer);
return;
 	}
 	
 	//briefing
 	fread(&i,2,1,f);
 	
 	j=0;
 	m=0;
 	
 	FontSetSys(1);
 	
 	do{
 	clrgrayscr();
 	for(k=0;k<88;k+=8)
 	{
 		for(l=0;l<156;l+=6)
 		{
 			
 			fread(&str,1,1,f);
 			if(str==151) m=1;
 			if(m==0)
 			printf_xy (l, k,"%c", str); 
 			j++;
			if(j>=i)  break;
 		}
 		if(j>=i)  break;
 	}
 	
 	DrawStr(53,92,"Press 2nd",4);
 	
 	while(!(_rowread(ARROWS_ROW)&SECOND_KEY));
 	while(_rowread(ARROWS_ROW)&SECOND_KEY);
 	
 	if(m==1)
 	{
 		while(j<i){
 			fread(&str,1,1,f);
 			j++;
 		}
 	}
 	
 	}while(j<i);
 	
 	
 	FontSetSys(0);
 	
 	SetPlane(LIGHT_PLANE);
	clrscr();
	SetPlane(DARK_PLANE);
	clrscr();
	
 	
 	fread(&mapwidth,2,1,f);
 	fread(&mapheight,2,1,f);
 	fread(&curmapx,2,1,f);
 	fread(&curmapy,2,1,f);
 	fread(&yourside,2,1,f);
 	
 	if(yourside==0) enemyside=1;
 	else enemyside=0;
 	
 	fread(&money,2,1,f);
 	fread(&enemymoney,2,1,f);
 	fread(&techlevel,2,1,f);
 	
 	//teams
 	fread(&i,2,1,f);
 	for(j=0;j<i;j++)
 	{
 			fread(&teams[j][0],2,11,f);
 	}
 	
 	//orders
 	fread(&i,2,1,f);
 	for(j=0;j<i;j++)
 	{
 			fread(&order[j][0],2,3,f);
 	}
 	
 	//triggers
 	fread(&i,2,1,f);
 	for(j=0;j<i;j++)
 	{
 			fread(&triggers[j][0],2,6,f);
 	}
 	
 	//enemy to build
 	fread(&i,2,1,f);
 	for(j=0;j<i;j++)
 	{
 			fread(&enemytobuild[j][0],2,3,f);
 	}
 	
 	
 	//terrain
 	fread(&i,2,1,f);
 	for(j=0;j<i;j++)
 	{
 			fread(&moveorder[0],1,1,f);
 			fread(&moveorder[1],1,1,f);
	 		fread(&moveorder[2],1,1,f);
	map[(int)moveorder[1]][(int)moveorder[0]]=moveorder[2];
 	}
 	
 	//tiberium
 	fread(&i,2,1,f);
 	for(j=0;j<i;j++)
 	{
 			fread(&moveorder[0],1,1,f);
 			fread(&moveorder[1],1,1,f);
	 		fread(&tmap[(int)moveorder[1]][(int)moveorder[0]],1,1,f);
 	}
 	
 	/*
 	for(i=0;i<14;i++)
 	{
 		map[terrainlist[i][1]][terrainlist[i][0]]=terrainlist[i][2];
 	}
 
  
  //tiberium
	for(i=0;i<10;i++)
	{
			tmap[starttiberium[i][1]][starttiberium[i][0]]=starttiberium[i][2];		
	}
	*/
  fread(&i,2,1,f);
 	for(j=0;j<i;j++)
 	{
	 		fread(&allunits[j+MAX_UNITS].col,2,1,f);
			fread(&allunits[j+MAX_UNITS].row,2,1,f);
			fread(&allunits[j+MAX_UNITS].type,2,1,f);
			fread(&allunits[j+MAX_UNITS].side,2,1,f);
			
			fread(&k,2,1,f);
			
			side_a=allunittypes[allunits[j+MAX_UNITS].type].maxhp;
 			side_b=side_a*k/100;
 			allunits[j+MAX_UNITS].hp=floor(side_b);

			fread(&allunits[j+MAX_UNITS].trigger,2,1,f);
			
 	}
 	
  
  /*
  allunits[MAX_UNITS].col=5;
  allunits[MAX_UNITS].row=0;
  allunits[MAX_UNITS].type=NUKE;
  allunits[MAX_UNITS].side=0;
  allunits[MAX_UNITS].hp=150;
  
  
  
  allunits[MAX_UNITS+1].col=1;
  allunits[MAX_UNITS+1].row=1;
  allunits[MAX_UNITS+1].type=YARD;
  allunits[MAX_UNITS+1].side=0;
  allunits[MAX_UNITS+1].hp=400;
  
  
  allunits[MAX_UNITS+2].col=3;
  allunits[MAX_UNITS+2].row=5;
  allunits[MAX_UNITS+2].type=WEAP;
  allunits[MAX_UNITS+2].side=0;
  allunits[MAX_UNITS+2].hp=260;
  
  allunits[MAX_UNITS+3].col=9;
  allunits[MAX_UNITS+3].row=2;
  allunits[MAX_UNITS+3].type=PROC;
  allunits[MAX_UNITS+3].side=0;
  allunits[MAX_UNITS+3].hp=200;
  
  
  allunits[MAX_UNITS+4].col=20;
  allunits[MAX_UNITS+4].row=16;
  allunits[MAX_UNITS+4].type=PROC;
  allunits[MAX_UNITS+4].side=1;
  allunits[MAX_UNITS+4].hp=300;
  
  allunits[MAX_UNITS+6].col=23;
  allunits[MAX_UNITS+6].row=20;
  allunits[MAX_UNITS+6].type=WEAP;
  allunits[MAX_UNITS+6].side=1;
  allunits[MAX_UNITS+6].hp=300;
 
 	allunits[MAX_UNITS+7].col=23;
  allunits[MAX_UNITS+7].row=25;
  allunits[MAX_UNITS+7].type=NUKE;
  allunits[MAX_UNITS+7].side=1;
  allunits[MAX_UNITS+7].hp=150;
 
 	allunits[MAX_UNITS+8].col=27;
  allunits[MAX_UNITS+8].row=20;
  allunits[MAX_UNITS+8].type=COMM;
  allunits[MAX_UNITS+8].side=1;
  allunits[MAX_UNITS+8].hp=250;
  
  allunits[MAX_UNITS+9].col=27;
  allunits[MAX_UNITS+9].row=27;
  allunits[MAX_UNITS+9].type=YARD;
  allunits[MAX_UNITS+9].side=1;
  allunits[MAX_UNITS+9].hp=400;
 */
 
  
  for(i=MAX_UNITS;i<MAX_UNITS+MAX_BUILDINGS;i++)
  {
  	if(allunits[i].col>=0)
  	{
  	allunits[i].x=allunits[i].col*16+8;
  	allunits[i].y=allunits[i].row*16+8;
  	allunits[i].builder=allunits[i].side;
  
  	if(allunittypes[allunits[i].type].speed>0){
			placebuilding(i);
			
  		
  		}
  		else map[allunits[i].row][allunits[i].col]=i;
  		
  	}
  }
  
  fread(&i,2,1,f);
 	for(j=0;j<i;j++)
 	{
	 		fread(&allunits[j+1].col,2,1,f);
			fread(&allunits[j+1].row,2,1,f);
			fread(&allunits[j+1].direction,2,1,f);
			fread(&allunits[j+1].type,2,1,f);
			fread(&allunits[j+1].side,2,1,f);
			fread(&k,2,1,f);
			
			side_a=allunittypes[allunits[j+1].type].maxhp;
 			side_b=side_a*k/100;
 			allunits[j+1].hp=floor(side_b);

			fread(&allunits[j+1].trigger,2,1,f);
			
 	}
 	
  fclose(f);
  
  /*
  allunits[1].col=3;
  allunits[1].row=3;
  allunits[1].direction=225;
  allunits[1].side=0;
  allunits[1].type=LTNK;
  allunits[1].hp=60;
  
  allunits[3].col=4;
  allunits[3].row=4;
  allunits[3].direction=1125;
  allunits[3].side=0;
  allunits[3].type=MTNK;
  allunits[3].hp=80;
  
	allunits[2].col=7;
  allunits[2].row=2;
  allunits[2].direction=2025;
  allunits[2].side=1;
  allunits[2].type=MTNK;
  allunits[2].hp=60;
  
  allunits[4].col=28;
  allunits[4].row=15;
  allunits[4].direction=2025;
  allunits[4].side=1;
  allunits[4].type=HARV;
  allunits[4].hp=160;
  
  allunits[5].col=5;
  allunits[5].row=4;
  allunits[5].direction=1125;
  allunits[5].side=0;
  allunits[5].type=HARV;
  allunits[5].hp=160;
  */
  
  for(i=0;i<MAX_UNITS;i++)
  {
  	if(allunits[i].col>=0)
  	{
  map[allunits[i].row][allunits[i].col]=i;

  allunits[i].x=allunits[i].col*16+8;
	allunits[i].y=allunits[i].row*16+8;
	allunits[i].oldcol=allunits[i].col;
	allunits[i].oldrow=allunits[i].row;
	allunits[i].olddir=allunits[i].direction;
	allunits[i].destdir=allunits[i].direction;
	allunits[i].destx=allunits[i].x;
	allunits[i].desty=allunits[i].y;
	allunits[i].findestcol=allunits[i].col;
	allunits[i].findestrow=allunits[i].row;
	allunits[i].destcol=allunits[i].col;
	allunits[i].destrow=allunits[i].row;
	allunits[i].curspeed=0;
	allunits[i].select=0;
	allunits[i].mode=STOP;
	allunits[i].store=0;
 	allunits[i].builder=allunits[i].side;

  	}
  }
  
 j=0;
 //allow victory if no such trigger
  for(i=0;i<MAX_TRIGGERS;i++)
  {
  	if(triggers[i][2]==ALLOWVICTORY) j=1;
  }
	if(j==0) allowvictory=0;
	

j=0;
	//remove fog in sight range	
	for(i=1;i<MAX_UNITS+MAX_BUILDINGS;i++)
	{
		if(allunits[i].x>0&&allunits[i].side==yourside)
		{
			fogremover(allunits[i].col,allunits[i].row,allunittypes[allunits[i].type].sight);		
			
			
			if(j==0)
			{
				//start screen on your unit
				curmapx=allunits[i].x-80;
				curmapy=allunits[i].y-50;
				fixscreen();


	
				j=1;
			}
		}
			
	}
	

for(j=0;j<3;j++){
		allbuilders[j].type=searchfornext(allbuilders[j].type,1,j-j/2);
		inview[j-j/2]=allbuilders[j].type;
			}	
		

  
  }
	
	
	
	
 	
 	
 		

	//drawmap();
	
	CursorSprite16(col,row,cursor+32*curset,0);
		
		selectbox[0]=-1;
	
	do{
	
	
if(redraw==1)
{
	redraw=0;

		drawmap();
	if(oldcurset<50)  CursorSprite16(oldcol,oldrow,cursor+32*oldcurset,0);
	if(oldcurset==50)	
		drawbuilding((oldcol+curmapx+8)/16*16,(oldrow+curmapy+8)/16*16,allunittypes[allbuilders[0].type].speed,
	allunittypes[allbuilders[0].type].rotate,allunittypes[allbuilders[0].type].pic,1,yourside,0);

}


	
	if(gamespeed<255){
		OSRegisterTimer(6,1);
	while(!OSTimerExpired(6));      // Delay
		}
	
  
  
	
	
	
	



	
//builders	
for(k=0;k<3;k++)
{

	if(allbuilders[k].current>0&&allbuilders[k].oldrow<16)
	{
		if(allbuilders[k].current<allbuilders[k].done) allbuilders[k].current++;
		
		if(allbuilders[k].current>=allbuilders[k].done&&money>allunittypes[allbuilders[k].type].cost/16)
		{
			
			DrawInt(0,35,money,0);
			money-=allunittypes[allbuilders[k].type].cost/16;
			if(currenttiberium>0)  currenttiberium-=allunittypes[allbuilders[k].type].cost/16;
			DrawInt(0,35,money,0);
			
			allbuilders[k].oldrow++;
			allbuilders[k].current=1;
			
			if((k==0&&allbuilders[k].type==inview[0])||(k>0&&allbuilders[k].type==inview[1]))
			GrayLine(1,allbuilders[k].oldrow+allbuilders[k].y,16,allbuilders[k].oldrow+allbuilders[k].y,2);
		}
			
	if(allbuilders[k].oldrow==16){
	
	DrawInt(0,35,money,0);
	money-=allunittypes[allbuilders[k].type].cost-allunittypes[allbuilders[k].type].cost/16*16;
	if(currenttiberium>0)  currenttiberium-=allunittypes[allbuilders[k].type].cost-allunittypes[allbuilders[k].type].cost/16*16;
	DrawInt(0,35,money,0);
			
			
	DrawStr(20,allbuilders[k].y+6,"DONE",2);

	
	if(k>0){
		
	
	allbuilders[k].current=0;
 	allbuilders[k].oldrow=0;
 	
 	for(j=MAX_UNITS;j<MAX_UNITS+MAX_BUILDINGS;j++)
 	{
 		if(allunits[j].type==allunittypes[allbuilders[k].type].pre1&&allunits[j].side==yourside) break;
 	}
 	
 	
 	
 	
 	if(inview[1]==allbuilders[k].type){
 	for(i=71;i<87;i++)
 	{
 		DrawLine(1,i,16,i,A_XOR);
 		SetPlane(LIGHT_PLANE);
		DrawLine(1,i,16,i,A_XOR);
		SetPlane(DARK_PLANE);	
 	}
 	}
 	
 	for(i=1;i<MAX_UNITS;i++)
 	{
 		if(allunits[i].col<0) break;
 	}
 	
 	creatingunit(i,allunits[j].row+1+allunittypes[allbuilders[k].type].pre1/WEAP,allunits[j].col,2025,yourside,allbuilders[k].type,allunittypes[allbuilders[k].type].maxhp);

	allunits[i].findestrow=allunits[i].row+1;
	
  GraySprite16(allunits[i].x-8,allunits[i].y-8,pics+32*(allunittypes[allunits[i].type].pic+4),0,0);
	
	}

	}		
	}
	
}


 	
 	
 	
 	//build building or unit
 	if((_rowread(F1_ROW)&FX_KEY&&checkforunit(YARD,yourside,-1))||(_rowread(F2_ROW)&FX_KEY&&(checkforunit(WEAP,yourside,-1)||checkforunit(PYLE,yourside,-1))))
 	{
if(_rowread(F1_ROW)&FX_KEY)
{
	keyer=F1_ROW;
	k=0;	
}

if(_rowread(F2_ROW)&FX_KEY)
{
	keyer=F2_ROW;
if(allunittypes[inview[1]].rotate<20) k=1;
else k=2;	
}



 		while(_rowread(keyer)&FX_KEY);
		
		
	if(curset==50&&k==0){  //place building
	
	if(drawbuilding((col+curmapx+8)/16*16,(row+curmapy+8)/16*16,allunittypes[allbuilders[k].type].speed,
	allunittypes[allbuilders[k].type].rotate,allunittypes[allbuilders[k].type].pic,1,yourside,0))
	{
	
	
	curset=0;
	
	//reset build que
	allbuilders[k].current=0;
	allbuilders[k].oldrow=0;
	
	if(allbuilders[k].type==inview[0]){
	for(i=51;i<67;i++)
 	{
 		DrawLine(1,i,16,i,A_XOR);
 		SetPlane(LIGHT_PLANE);
		DrawLine(1,i,16,i,A_XOR);
		SetPlane(DARK_PLANE);	
 	}
 	}
	
 	DrawStr(20,allbuilders[k].y+6,"DONE",2);
	
	//for standard buildings
 	if(allunittypes[allbuilders[k].type].speed>0){
 		for(i=MAX_UNITS;i<MAX_UNITS+MAX_BUILDINGS;i++)
 	{
 		if(allunits[i].col<0) break;
 	}
 	}
 	
 	//else for turrets
 	else
 	{
 		for(i=1;i<MAX_UNITS;i++)
 	{
 		if(allunits[i].col<0) break;
 	}	
 	}
 	
 	
 	j=0;
	
	if(!(checkforunit(PYLE,yourside,-1)||checkforunit(WEAP,yourside,-1)))
	j=1;
	
 	
 	
 	creatingunit(i,(row+curmapy+8)/16,(col+curmapx+8)/16,225,yourside,allbuilders[k].type,allunittypes[allbuilders[k].type].maxhp);
  
  
  
	if(j==1){
	allbuilders[1].type=searchfornext(allbuilders[1].type,1,1);
	inview[1]=allbuilders[1].type;
}


  for(j=MAX_UNITS;j<MAX_UNITS+MAX_BUILDINGS;j++)
  {
  	if(allunits[j].type==YARD&&allunits[j].side==yourside) break;
  }
	allunits[i].builder=allunits[j].builder;

	
  drawbuilding((col+curmapx+8)/16*16,(row+curmapy+8)/16*16,allunittypes[allbuilders[k].type].speed,
	allunittypes[allbuilders[k].type].rotate,allunittypes[allbuilders[k].type].pic,1,yourside,0);	
	
	
  if(allunittypes[allbuilders[k].type].speed>0){
			placebuilding(i);
			}	
	else
	map[allunits[i].row][allunits[i].col]=i;
 	
 	
 	//make a harvester if built refinery
	if(allbuilders[0].type==PROC) { 
	redraw=1;
	
		for(i=1;i<MAX_UNITS;i++)
 	{
 		if(allunits[i].col<0) break;
 	}	
 	
	
	creatingunit(i,(row+curmapy+8)/16+3,(col+curmapx+8)/16,2025,yourside,HARV,allunittypes[HARV].maxhp);
  map[(row+curmapy+8)/16+3][(col+curmapx+8)/16]=i;
  }
 	
 	}
	
	else
	drawbuilding((col+curmapx+8)/16*16,(row+curmapy+8)/16*16,allunittypes[allbuilders[k].type].speed,
	allunittypes[allbuilders[k].type].rotate,allunittypes[allbuilders[k].type].pic,1,yourside,0);	
		
	
	
  
	
	
	}	
		
		else	{
		
		DrawStr(20,allbuilders[k].y,"BUILD MODE",2);
		DrawStr(20,allbuilders[k].y+6,unitnames[inview[k-k/2]],2);
		DrawStr(20,allbuilders[k].y+12,"$",2);
		
		DrawInt(26,allbuilders[k].y+12,allunittypes[inview[k-k/2]].cost,0);
		
		while(!(_rowread(keyer)&FX_KEY)&&!(_rowread(ARROWS_ROW)&DIAMOND_KEY))
		{
			
			while(!(_rowread(ARROWS_ROW)&LEFT_KEY)&&!(_rowread(ARROWS_ROW)&RIGHT_KEY)&&!(_rowread(keyer)&FX_KEY)&&!(_rowread(ARROWS_ROW)&DIAMOND_KEY));
			
			
			
				CursorSprite16(1,allbuilders[k].y+1,pics+32*(allunittypes[inview[k-k/2]].pic+4*(k-k/2)),0);
				
				
				
				DrawInt(26,allbuilders[k].y+12,allunittypes[inview[k-k/2]].cost,0);
				DrawStr(20,allbuilders[k].y+6,unitnames[inview[k-k/2]],2);
		
				
				if(allbuilders[k].type==inview[k-k/2]&&allbuilders[k].oldrow>0)
				{
					for(i=0;i<allbuilders[k].oldrow;i++)
					{
						GrayLine(1,allbuilders[k].y+1+i,16,allbuilders[k].y+1+i,2);
					}					  
				}
				if(allbuilders[k].type!=inview[k-k/2]&&allbuilders[k].oldrow>0){
					for(i=0;i<16;i++) GrayLine(1,allbuilders[k].y+1+i,16,allbuilders[k].y+1+i,0);
				}

				if(_rowread(ARROWS_ROW)&LEFT_KEY){	
				inview[k-k/2]=searchfornext(inview[k-k/2],-1,k-k/2);
				while(_rowread(ARROWS_ROW)&LEFT_KEY);
				}
				
				if(_rowread(ARROWS_ROW)&RIGHT_KEY){	
				inview[k-k/2]=searchfornext(inview[k-k/2],1,k-k/2);
				while(_rowread(ARROWS_ROW)&RIGHT_KEY);
				}
				
				
				//change k
				if(k>0){
				if(allunittypes[inview[k-k/2]].rotate<20) k=1;
				else k=2;
				}
				
				if(allbuilders[k].type==inview[k-k/2]&&allbuilders[k].oldrow>0)
				{
					for(i=0;i<allbuilders[k].oldrow;i++)
					{
						GrayLine(1,allbuilders[k].y+1+i,16,allbuilders[k].y+1+i,2);
					}					  
				}
				if(allbuilders[k].type!=inview[k-k/2]&&allbuilders[k].oldrow>0){
					for(i=0;i<16;i++) GrayLine(1,allbuilders[k].y+1+i,16,allbuilders[k].y+1+i,0);
				}
				
				DrawInt(26,allbuilders[k].y+12,allunittypes[inview[k-k/2]].cost,0);
				DrawStr(20,allbuilders[k].y+6,unitnames[inview[k-k/2]],2);
			
				CursorSprite16(1,allbuilders[k].y+1,pics+32*(allunittypes[inview[k-k/2]].pic+4*(k-k/2)),0);
			
		}
		
		if((_rowread(ARROWS_ROW)&DIAMOND_KEY))
		{
			DrawInt(0,35,money,0);
			
			if(allbuilders[k].oldrow>0&&allbuilders[k].oldrow<16)
			{
				money+=allunittypes[allbuilders[k].type].cost/16*allbuilders[k].oldrow;
			}
			if(allbuilders[k].oldrow==16)  money+=allunittypes[allbuilders[k].type].cost;
			DrawInt(0,35,money,0);
			
			if(allbuilders[k].type==inview[k-k/2]&&allbuilders[k].oldrow>0)
				{
					for(i=0;i<allbuilders[k].oldrow;i++)
					{
						GrayLine(1,allbuilders[k].y+1+i,16,allbuilders[k].y+1+i,2);
					}					  
				}
				else	{for(i=0;i<16;i++) GrayLine(1,allbuilders[k].y+1+i,16,allbuilders[k].y+1+i,0);}
				
			
			allbuilders[k].current=0;
			allbuilders[k].done=allunittypes[inview[k-k/2]].cost/4;
			
			allbuilders[k].oldrow=0;		
			allbuilders[k].type=inview[k-k/2];		
			
			
			
		}
		if(_rowread(keyer)&FX_KEY){
		
		
		if(allbuilders[k].oldrow==0){
			allbuilders[k].current=1;
			allbuilders[k].done=allunittypes[inview[k-k/2]].cost/4;	
			
			if(poweroutput<powerconsumption)  allbuilders[k].done*=4;

j=0;
for(i=MAX_UNITS;i<MAX_UNITS+MAX_BUILDINGS;i++)
{
	if(allunits[i].type==allunittypes[allbuilders[k].type].pre1&&allunits[i].x>0&&allunits[i].side==yourside) j++;
}
if(j!=0)
allbuilders[k].done/=(sqrt(j)+1);
			
			
			allbuilders[k].type=inview[k-k/2];		
			}
			
		}
		
		
		while(_rowread(keyer)&FX_KEY||(_rowread(ARROWS_ROW)&DIAMOND_KEY));
		
		DrawStr(20,allbuilders[k].y,"BUILD MODE",2);
		DrawStr(20,allbuilders[k].y+6,unitnames[inview[k-k/2]],2);
		DrawStr(20,allbuilders[k].y+12,"$",2);
		
		DrawInt(26,allbuilders[k].y+12,allunittypes[inview[k-k/2]].cost,0);
		
		
		if(allbuilders[k].oldrow==16&&k==0)
		{
			curset=50;		
		}
		}
		
		
 	}
 	
 	
 	


 	
 	
 	
 	
 	
 	
 	
 			
 	//warning
 	
  if(warning[0]>1)
  {
  	//make after scrolling
 	//if(ministart<-5)  GrayRect(warning[2]-warning[0]/2,warning[3]-warning[0]/2,
	//					warning[2]+warning[0]/2,warning[3]+warning[0]/2,1);
	
  	
  	warning[1]--;
  	if(warning[1]<=0)
  	{
  		if(poweroutput>powerconsumption&&checkforunit(COMM,yourside,-1))
  		GrayRect(warning[2]-warning[0]/2,warning[3]-warning[0]/2,
						warning[2]+warning[0]/2,warning[3]+warning[0]/2,1);
						
  		warning[0]--;
  		warning[1]=15;
  		if(warning[0]>1&&poweroutput>powerconsumption&&checkforunit(COMM,yourside,-1)) GrayRect(warning[2]-warning[0]/2,warning[3]-warning[0]/2,
						warning[2]+warning[0]/2,warning[3]+warning[0]/2,1);
						
  	}
  	
  	
  }
 	


//groups by number
if(_rowread(ARROWS_ROW)&SHIFT_KEY)
{
	
	j=1;
	for(k=2;k<=8;k*=2)
	{
		for(side_a=NEGATIVE_ROW;side_a>=ZERO_ROW;side_a-=4)
		{
			if(_rowread(side_a)&k)
			{
				for(i=1;i<MAX_UNITS;i++)
				{
				if(allunits[i].order==j&&allunits[i].side==yourside)  allunits[i].order=0;
				if(allunits[i].select==1&&allunits[i].side==yourside)  allunits[i].order=j;
			
				}
				while(_rowread(side_a)&k);
				
						
			}
			
			if(side_a==DOT_ROW)  side_a-=4;
				j++;
		}
	}

	
	
}


//select group number
if(_rowread(ARROWS_ROW)&ALPHA_KEY){


j=1;
	for(k=2;k<=8;k*=2)
	{
		for(side_a=NEGATIVE_ROW;side_a>=ZERO_ROW;side_a-=4)
		{
			if(_rowread(side_a)&k)
			{
				selectgroup(j,&curset,oldcurset,oldcol,oldrow);
				
				while(_rowread(side_a)&k);
				
						
			}
			if(side_a==DOT_ROW)  side_a-=4;
				j++;
		}
	}


}




	//center on attacked unit
if(_rowread(ARROWS_ROW)&SHIFT_KEY&&_rowread(F1_ROW)&APPS_KEY)
{
	curmapx=(warning[2])*16-72;
	curmapy=(warning[3])*16-42;
fixscreen();	
	
redraw=1;	
}
	
//ceneter over your base
if(_rowread(ARROWS_ROW)&ALPHA_KEY&&_rowread(F1_ROW)&APPS_KEY)
{
for(i=MAX_UNITS;i<MAX_UNITS+MAX_BUILDINGS;i++)
{
	if(allunits[i].type==YARD&&allunits[i].side==yourside&&allunits[i].x>0) break;
}

if(i<MAX_UNITS+MAX_BUILDINGS){
	curmapx=allunits[i].x-72;
	curmapy=allunits[i].y-42;
fixscreen();	
}
	
	redraw=1;
}

	
	//F3 easy scroll around on minimap
 	if(_rowread(F3_ROW)&FX_KEY&&poweroutput>powerconsumption&&checkforunit(COMM,yourside,-1))
 	{
 		while((_rowread(F3_ROW)&FX_KEY));
 		
 		DrawStr(mapwidth/(mapwidth/33+1)+2,mapheight/(mapheight/33+1)*1/2-3,"MINI-MAP MODE",2);
 		
 		while(!(_rowread(F3_ROW)&FX_KEY))
 		{
 			for(i=0;i<10;i++){
 			OSRegisterTimer(6,1);
			while(!OSTimerExpired(6));      // Delay
			}
	
			GrayRect((curmapx/16)/(mapwidth/33+1), (curmapy/16)/(mapheight/33+1), ((curmapx+160-16)/16)/(mapwidth/33+1), ((curmapy+100-16)/16)/(mapheight/33+1),0);

 			key=_rowread(ARROWS_ROW);
 			if(key&LEFT_KEY)  curmapx-=16;
 			if(key&RIGHT_KEY)  curmapx+=16;
 			if(key&UP_KEY)  curmapy-=16;
 			if(key&DOWN_KEY)  curmapy+=16;
			
			if(curmapx>mapwidth*16-160) curmapx=mapwidth*16-160;	
			if(curmapx<0) curmapx=0;	
			if(curmapy>mapheight*16-100) curmapy=mapheight*16-100;	
			if(curmapy<0) curmapy=0;	
	
			GrayRect((curmapx/16)/(mapwidth/33+1), (curmapy/16)/(mapheight/33+1), ((curmapx+160-16)/16)/(mapwidth/33+1), ((curmapy+100-16)/16)/(mapheight/33+1),0);
 			
 		}
 	
 		while((_rowread(F3_ROW)&FX_KEY));
 		
 		
 		
 	redraw=1;	
 		
 	}


//F4 repair building
if(_rowread(F4_ROW)&FX_KEY)
{
	for(i=1;i<MAX_UNITS+MAX_BUILDINGS;i++)
	{
		if(allunits[i].select==1&&allunittypes[allunits[i].type].speed<4&&allunits[i].side==yourside)
		{
			switch(allunits[i].repair)
			{
				case 0: allunits[i].repair=1; break;
				case 1: allunits[i].repair=0; break;
			}
		}
		
	}
	while(_rowread(F4_ROW)&FX_KEY);

}


//F5 sell buiding
if((_rowread(ARROWS_ROW)&SHIFT_KEY)&&(_rowread(F5_ROW)&FX_KEY))
{
for(i=1;i<MAX_UNITS+MAX_BUILDINGS;i++)
{
	if(allunits[i].select==1&&allunittypes[allunits[i].type].speed<4&&allunits[i].side==yourside)
	{
		
		money+=allunittypes[allunits[i].type].cost/2;
		
		
		allunits[i].hp=0;
		killdead=1;

	}
	
}

	

while(_rowread(F5_ROW)&FX_KEY);
}



//spread of tiberium
tiberiumgrowthtimer++;
if(tiberiumgrowthtimer>15000)
{

	tiberiumgrowthtimer=0;
	
	
	
	
	for(k=0;k<mapheight;k++)
	{
		for(i=0;i<mapwidth;i++)
		{
			
			//biggest fill adjacent squares
		if(tmap[k][i]==10)
		{
			if(map[k-1][i]==0&&tmap[k-1][i]==0&&k>0)
			{
				tmap[k-1][i]=7;
			}
			
			if(map[k][i-1]==0&&tmap[k][i-1]==0&&i>0)
			{
				tmap[k][i-1]=7;
			}
			
			if(map[k+1][i]==0&&tmap[k+1][i]==0&&k<mapheight-1)
			{
				tmap[k+1][i]=7;
			}
			
			if(map[k][i+1]==0&&tmap[k][i+1]==0&&i<mapwidth-1)
			{
				tmap[k][i+1]=7;
			}
			
		}
		}
	}

		
			
	for(k=0;k<mapheight;k++)
	{
		for(i=0;i<mapwidth;i++)
		{
			//smaller become more dense
			if(tmap[k][i]==7||tmap[k][i]==8||tmap[k][i]==9)
			tmap[k][i]++;	
		}
	}	
		
	
		
		
		
		
		
	
	
	
	redraw=1;
	
}



//enemy build que
	if(enemybuildque[0]==0&&teams[0][0]!=0){
 		
 	m=0;  //used to prevent infinite looping	
 		
 		
 		//build que
 		for(i=enemybuildque[2]+2;i<11;i+=2)
 		{
 			if(teams[enemybuildque[1]][i]>0&&checkforunit(allunittypes[teams[enemybuildque[1]][i]].pre1,enemyside,-1))  
 			{
 				enemybuildque[2]=i;
 				enemybuildque[0]=teams[enemybuildque[1]][i-1];
 				break;	
 			}
 			
 			//next team
 			if(i>=10) 
 			{
 				//give team its orders
 		for(k=2;k<11;k+=2){
 		
 		for(j=teams[enemybuildque[1]][k-1];j>0;j--){
 		
 		for(i=1;i<MAX_UNITS;i++)
 		{
 			if(allunits[i].type==teams[enemybuildque[1]][k]&&allunits[i].side!=yourside&&allunits[i].order==0
 			&&allunits[i].x>0&&allunits[i].trigger==0){
 			allunits[i].order=teams[enemybuildque[1]][0];  	
 			break;
 			}
 		
 		}
 		}
 		
 		}
 				
 				enemybuildque[1]++;
 				if(teams[enemybuildque[1]][2]==0){  enemybuildque[1]=0; m++;} 				 				
 				if(m>2) break;
 				
 				i=0;
 			}
 			
 		}
 		
 		
 		}
	
	
	if(enemybuilder[2]==0&&teams[enemybuildque[1]][enemybuildque[2]]>0&&enemymoney>allunittypes[teams[enemybuildque[1]][enemybuildque[2]]].cost)
	{
	
	enemybuilder[0]=0;
		
	
	//check for buildings to be built
	for(i=0;i<MAX_TOBUILDS;i++)
	{
		//if building is not there
		if((enemytobuild[i][0]>0||enemytobuild[i][1]>0)&&map[enemytobuild[i][1]][enemytobuild[i][0]]==0)
		{
		enemybuilder[0]=i+1;	
		enemybuilder[2]=1;
		enemybuilder[3]=allunittypes[enemytobuild[i][2]].cost*4;
		enemymoney-=allunittypes[enemytobuild[i][2]].cost;	
		break;
		}
	}
	
		if(enemybuilder[0]==0){
		enemybuilder[2]=1;
		
		//check for harvester
		for(i=1;i<MAX_UNITS;i++)
		{
			if(allunits[i].type==HARV&&allunits[i].side!=yourside&&allunits[i].x>0) break;
		}
		if(i==MAX_UNITS&&checkforunit(PROC,enemyside,-1)&&checkforunit(WEAP,enemyside,-1))
		{
		enemybuilder[3]=allunittypes[HARV].cost*4;
		enemymoney-=allunittypes[HARV].cost;
		}
		
		
		else{
			
		enemybuilder[3]=allunittypes[teams[enemybuildque[1]][enemybuildque[2]]].cost*4;
		enemymoney-=allunittypes[teams[enemybuildque[1]][enemybuildque[2]]].cost;
		}
		
		}

	}
	
	
	if(enemybuilder[2]>0)
	{
		enemybuilder[2]++;
	
	
		if(enemybuilder[2]==enemybuilder[3])
		{
		enemybuilder[2]=0;
		
		
		//for units
		if(enemybuilder[0]==0)
		{
			
		
  
		
		
	for(i=1;i<MAX_UNITS;i++)
 	{
 		if(allunits[i].col<0) break;
 	}
 	
	//harvester built
if(enemybuilder[3]==allunittypes[HARV].cost*4)	
{
		for(j=MAX_UNITS;j<MAX_UNITS+MAX_BUILDINGS;j++)
 	{
 		if(allunits[j].type==WEAP&&allunits[j].side!=yourside) break;
 	}

		 creatingunit(i,allunits[j].row+2,allunits[j].col,2025,enemyside,HARV,allunittypes[HARV].maxhp);
		  	
}
else{
		enemybuildque[0]--;

 	if(allunittypes[teams[enemybuildque[1]][enemybuildque[2]]].rotate<20){
 	for(j=MAX_UNITS;j<MAX_UNITS+MAX_BUILDINGS;j++)
 	{
 		if(allunits[j].type==WEAP&&allunits[j].side!=yourside) break;
 	}
 	}
 	else
 	{
 		for(j=MAX_UNITS;j<MAX_UNITS+MAX_BUILDINGS;j++)
 	{
 		if(allunits[j].type==PYLE&&allunits[j].side!=yourside) break;
 	}
 	}
 	 	
 	 	
 creatingunit(i,allunits[j].row+2,allunits[j].col,2025,enemyside,teams[enemybuildque[1]][enemybuildque[2]],allunittypes[teams[enemybuildque[1]][enemybuildque[2]]].maxhp);
} 
  
  
	allunits[i].findestcol=allunits[i].col-2;
	allunits[i].findestrow=allunits[i].row+2;
	
	
	
  GraySprite16(allunits[i].x-8,allunits[i].y-8,pics+32*(allunittypes[allunits[i].type].pic+4),0,enemyside);
	}			
			
	
	
	
	
	
	
	
	//for buildings
	if(enemybuilder[0]>0)
	{		
		
	//for standard buildings
 	if(allunittypes[enemytobuild[enemybuilder[0]-1][2]].speed>0){
 		for(i=MAX_UNITS;i<MAX_UNITS+MAX_BUILDINGS;i++)
 	{
 		if(allunits[i].col<0) break;
 	}
 	}
 	
 	//else for turrets
 	else
 	{
 		for(i=1;i<MAX_UNITS;i++)
 	{
 		if(allunits[i].col<0) break;
 	}	
 	}
 	
 	
 	creatingunit(i,enemytobuild[enemybuilder[0]-1][1],enemytobuild[enemybuilder[0]-1][0],225,enemyside,
 	enemytobuild[enemybuilder[0]-1][2],allunittypes[enemytobuild[enemybuilder[0]-1][2]].maxhp);
  


	
  
	
  if(allunittypes[enemytobuild[enemybuilder[0]-1][2]].speed>0){

placebuilding(i);
			}	
	else
	map[allunits[i].row][allunits[i].col]=i;
 	
 	
 	}
	
		
	
	//make a harvester if built refinery
	if(enemytobuild[enemybuilder[0]-1][2]==PROC) { 
	
		for(i=1;i<MAX_UNITS;i++)
 	{
 		if(allunits[i].col<0) break;
 	}	
 	
	creatingunit(i,enemytobuild[enemybuilder[0]-1][1]+3,enemytobuild[enemybuilder[0]-1][0],2025,enemyside,
 	HARV,allunittypes[HARV].maxhp);
  
	map[enemytobuild[enemybuilder[0]-1][1]+3][enemytobuild[enemybuilder[0]-1][0]]=i;
	
	closestsearch(&allunits[i].findestcol,&allunits[i].findestrow,-1,-1);
 	allunits[i].mode=MOVE;
 			
	
  }
  
		
		
	}
			
			
		
	}


 	
 	//minimap
 	ministart--;
 
 mapnum=0;	
 	
 	//repair units
 	if(ministart==200||ministart==100||ministart==0)
 	{
 		for(i=1;i<MAX_UNITS+MAX_BUILDINGS;i++)
 		{
 			//mammoths and harvesters auto repair
 			if((allunits[i].type==BTNK||allunits[i].type==HARV)&&allunits[i].hp*2<allunittypes[allunits[i].type].maxhp&&ministart==0)
 			allunits[i].hp+=2;
 			
 			
 			//repair bay
 			if(money>0&&allunits[i].type==BAY&&map[allunits[i].row][allunits[i].col+1]>0&&
 			allunits[map[allunits[i].row][allunits[i].col+1]].hp<allunittypes[allunits[map[allunits[i].row][allunits[i].col+1]].type].maxhp)
 			{
 				GraySprite16(allunits[i].x+8,allunits[i].y-24,cursor+32*9,0,0);
 				allunits[map[allunits[i].row][allunits[i].col+1]].hp+=2;
 				DrawInt(0,35,money,0);
 				money--;
 				DrawInt(0,35,money,0);	
 			}
 			
 			
 			
 			if((allunits[i].repair==1))
 			{
 	
 				j=0;
 				if(allunits[i].side==yourside&&money>0){
 				DrawInt(0,35,money,0);
 				money--;
 				DrawInt(0,35,money,0);
 				j=1;
 				}
 				
 				if(allunits[i].side!=yourside&&enemymoney>0){
 				enemymoney--;
 				j=1;
 				}
 				
 				if(j==1){
 				allunits[i].hp+=2;
 				GraySprite16(allunits[i].x-8,allunits[i].y-24,cursor+32*9,0,0);
 				}
 				
	
			if(allunits[i].hp>=allunittypes[allunits[i].type].maxhp)
 			{
 			allunits[i].hp=allunittypes[allunits[i].type].maxhp;
 			allunits[i].repair=0;
 			}
 			}
 			
 		}
 		
 	}
 	
 	
 	if(ministart<=0)
 	{
 		
 		//makemini(&minimap[0][0]);
 		
 		
 		ministart+=300;
 	
 		gametimer++;
 	
 		
//super weapons
if(checkforunit(ACOM,0,yourside)&&poweroutput>=powerconsumption&&superweapons[0]<IONCHARGE)
superweapons[0]++;

 	//ion cannon charged message
 	if(superweapons[0]>=IONCHARGE&&yourside==0){
 	for(i=0;i<3;i++)
 	{
 		if(allmessages[i][0]==0) break;
 	}
 	if(i<3)
 	{
 		allmessages[i][0]=1;
 		allmessages[i][1]=2;
 	}
 	}



if(checkforunit(TMPL,1,yourside)&&poweroutput>=powerconsumption&&superweapons[1]<NUKECHARGE)
superweapons[1]++;


 	//nuke charged message
 	if(superweapons[1]>=NUKECHARGE&&yourside==1){
 	for(i=0;i<3;i++)
 	{
 		if(allmessages[i][0]==0) break;
 	}
 	if(i<3)
 	{
 		allmessages[i][0]=1;
 		allmessages[i][1]=3;
 	}
 	}
 		
 	
 	//press alpha+F5 message
 	if((superweapons[1]>=NUKECHARGE&&yourside==1)||(superweapons[0]>=IONCHARGE&&yourside==0)){
 	for(i=0;i<3;i++)
 	{
 		if(allmessages[i][0]==0) break;
 	}
 	if(i<3)
 	{
 		allmessages[i][0]=1;
 		allmessages[i][1]=4;
 	}
 	}
 	
 	
 	
 	
 	
 	
 		if(divisible(gametimer,5)){	//do this less often to speed game up
 		
 		//triggers
 		for(i=0;i<MAX_TRIGGERS;i++)
 		{
 			
 			k=0;
 			
 			for(m=0;m<4;m+=2){
 			
 			l=0;	
 			
 			if(triggers[i][m]==0) continue;
 			
 			switch(triggers[i][m])
 			{
 				case ALLDEAD:
 				for(j=1;j<MAX_UNITS+MAX_BUILDINGS;j++)
 				{
 					if(allunits[j].side==triggers[i][m+1]&&allunits[j].x>0)  l=1;
 				}
 				if(l==0)	k=1;
 				break;
 				
 				
 				case GAMETIME:
 				if(gametimer>=triggers[i][m+1])	//if time has passed
 				k=1;		
 				break;

				
	 				
 				case UNITDEAD:  //when all units with a trigger are dead
 				for(j=1;j<MAX_UNITS+MAX_BUILDINGS;j++)
 				{
 					if(allunits[j].trigger==triggers[i][m+1]&&allunits[j].x>0)  l=1;
 				}
 				if(l==0)	k=1;
 				break;
 				
 				
				case EMONEY:  //if enemy money is below a value
 				if(enemymoney<triggers[i][m+1])  
 				k=1;		
 				break;
 				
 				case CAPTURE:	//if building with trigger is captured
 				for(j=MAX_UNITS;j<MAX_UNITS+MAX_BUILDINGS;j++)
 				{
 					if(allunits[j].trigger==triggers[i][m+1]&&allunits[j].side!=yourside)  l=1;
 				}
 				if(l==0)	k=1;
 				break;
 				
 				case DESTINATION:  //if unit with trigger moves to order coordinates
 				for(j=1;j<MAX_UNITS;j++)
 				{
 					if(allunits[j].trigger==triggers[i][m+1]&&(abs(allunits[j].col-order[triggers[i][m+1]][1])+abs(allunits[j].row-order[triggers[i][m+1]][2]))>2)  l=1;
 				}
 				if(l==0)	k=1;
 				break;
 				
 				case BUILDUNIT:  //if unit with trigger moves to order coordinates
 				for(j=1;j<MAX_UNITS+MAX_BUILDINGS;j++)
 				{
 					if(allunits[j].type==order[triggers[i][m+1]][2]&&allunits[j].side==yourside&&allunits[j].x>0)  l++;
 				}
 				if(l>=order[triggers[i][m+1]][1])	k=1;
 				break;
 				
				case MONEY:  //if your money is below a value
 				if(money>=triggers[i][m+1])  
 				k=1;		
 				break;
 				
 				case INTERVAL:
 				if(divisible(gametimer,triggers[i][m+1]))
 				k=1;
 				break;
 				
 				}
 				
 				if(k==0) break;
 				
 			}
 			
 			if(k==1)
 			{
 				switch(triggers[i][4])
 				{
 					case VICTORY:
 					if(allowvictory==0){
 					
 					clrgrayscr();
 					FontSetSys(1);
 					
 					DrawStr(32,46,"MISSION COMPLETE",2);
 					FontSetSys(0);
 					
 					for(j=0;j<50;j++){
 					for(i=0;i<30000;i++);
 					}
 					
 					
 					if(levelname[0]=='c')
 					{
 						if(levelname[strlen(levelname)-1]<'9')
 						levelname[strlen(levelname)-1]++;
 						else
 						{
 							levelname[strlen(levelname)-2]++;
 							levelname[strlen(levelname)-1]='0'; 
 						}
 						goto startover;	
 					}
 					
 					
 					endgame();
 							 LCD_restore (buffer);
return;
 					}
 					
 					break;
 					
 					case DEFEAT:
 					clrgrayscr();
 					FontSetSys(1);
 					DrawStr(38,46,"MISSION FAILED",2);
 					DrawStr(32,60,"Restarting level",2);
 					FontSetSys(0);
 					
 					for(j=0;j<50;j++){
 					for(i=0;i<30000;i++);
 					}
 						
 					clrgrayscr();
 					
 					goto startover;
 					break;
 				
 					case ORDERUNIT:	//give units with trigger an order. Order = trigger #
 					
 					if(triggers[i][0]!=9&&triggers[i][2]!=9)
 					triggers[i][4]=0;
 					
 					for(j=1;j<MAX_UNITS;j++)
 					{
 						if(allunits[j].trigger==triggers[i][5])
 						{
							allunits[j].order=triggers[i][5]; 								
 						}	
 					}
 					break;
 				
 					
					case ADDEMONEY:	
					//clear it so it is not run again
 					if(triggers[i][0]!=9&&triggers[i][2]!=9)
 					triggers[i][4]=0;
 					
 					enemymoney+=triggers[i][5];
	 				break;
 					
 					case FLARE:	//reveal terrain about coordinates located in order
 					
 					//clear it so it is not run again
 					if(triggers[i][0]!=9&&triggers[i][2]!=9)
 					triggers[i][4]=0;
 					
 					for(j=0;j<3;j++)
 					{
 						if(flares[j][0]<0) break;
 					}
 					flares[j][0]=order[triggers[i][5]][1];
 					flares[j][1]=order[triggers[i][5]][2];
 					
 					for(j=-2;j<3;j++)
 					{
 						for(l=-2;l<3;l++)
 						{
 							if((abs(j)+abs(l))<3)  fog[order[triggers[i][5]][2]+j][order[triggers[i][5]][1]+l]=0;		
 						}
 					}
 					break;
 					
 					case ALLOWVICTORY:  //allow victory
 					allowvictory=0;
 					break;
 					
 					
 					case EREINFORCEMENTS:
//clear it so it is not run again
 					if(triggers[i][0]!=9&&triggers[i][2]!=9)
 					triggers[i][4]=0;
 					 	//message
 	for(l=0;l<3;l++)
 	{
 		if(allmessages[l][0]==0) break;
 	}
 	if(l<3)
 	{
 		allmessages[l][0]=5;
 		allmessages[l][1]=6;
 	}
 	

 					
 						m=0;
 						for(l=2;l<11;l+=2)
 						{
 							for(j=teams[triggers[i][5]][l-1];j>0;j--){
 							
 							for(k=1;k<MAX_UNITS;k++)
 							{
 								if(allunits[k].x<0) break;
 							}
 							
 							for(n=0;n<20;n++){
							for(m=0;m<4;m++)
							{
								if(map[order[teams[triggers[i][5]][0]][2]+n][order[teams[triggers[i][5]][0]][1]+m]==0) break;
							}
								if(map[order[teams[triggers[i][5]][0]][2]+n][order[teams[triggers[i][5]][0]][1]+m]==0) break;
							}
							
							creatingunit(k, order[teams[triggers[i][5]][0]][2]+n, order[teams[triggers[i][3]][0]][1]+m, 250, enemyside, teams[triggers[i][3]][l], allunittypes[teams[triggers[i][3]][l]].maxhp);
 							allunits[k].order=teams[triggers[i][5]][0];
 							map[order[teams[triggers[i][5]][0]][2]+n][order[teams[triggers[i][5]][0]][1]+m]=k;
 							
 							
 							}
 						}
 					break;	
 					
 					
 					case REINFORCEMENTS:
//clear it so it is not run again
 					if(triggers[i][0]!=9&&triggers[i][2]!=9)
 					triggers[i][4]=0;
 					 	//message
 	for(l=0;l<3;l++)
 	{
 		if(allmessages[l][0]==0) break;
 	}
 	if(l<3)
 	{
 		allmessages[l][0]=5;
 		allmessages[l][1]=5;
 	}

 						m=0;
 						for(l=2;l<11;l+=2)
 						{
 							for(j=teams[triggers[i][5]][l-1];j>0;j--){
 							
 							for(k=1;k<MAX_UNITS;k++)
 							{
 								if(allunits[k].x<0) break;
 							}
 							
							for(n=0;n<20;n++){
							for(m=0;m<4;m++)
							{
								if(map[order[teams[triggers[i][5]][0]][2]+n][order[teams[triggers[i][5]][0]][1]+m]==0) break;
							}
								if(map[order[teams[triggers[i][5]][0]][2]+n][order[teams[triggers[i][5]][0]][1]+m]==0) break;
							}
							
							
							creatingunit(k, order[teams[triggers[i][5]][0]][2]+n, order[teams[triggers[i][5]][0]][1]+m, 250, yourside, teams[triggers[i][5]][l], allunittypes[teams[triggers[i][5]][l]].maxhp);
 							map[order[teams[triggers[i][5]][0]][2]+n][order[teams[triggers[i][5]][0]][1]+m]=k;
 							fogremover(allunits[k].col,allunits[k].row,allunittypes[allunits[k].type].sight);
 							
 							}
 						}
 					break;	
 					
 					
 					case MESSAGE:	//display message.  Located after briefing.
	 	if((f=fopen(levelname,"rb"))&&triggers[i][5]>0)
 	{
 	
 	fread(&m,2,1,f);

 	clrgrayscr();
 	
 	for(j=0;j<m;j++)	//searches for i (imaginary)
 	{
			fread(&str,1,1,f);
			if(str==151)  triggers[i][5]--;
			if(triggers[i][5]==0) break;  		
 	}
 	 		
 	FontSetSys(1);
 	
 	for(k=0;k<96;k+=8)
 	{
 		for(l=0;l<156;l+=6)
 		{
 			
 			fread(&str,1,1,f);
 			if(j>=m||str==151)  break;

 			printf_xy (l, k,"%c", str); 
 			j++;
 		}
 		if(j>=m||str==151)  break;
 	}
 	
 	DrawStr(53,92,"Press 2nd",4);
 	
 	while(!(_rowread(ARROWS_ROW)&SECOND_KEY));
 	while(_rowread(ARROWS_ROW)&SECOND_KEY);
 	
 	
 	FontSetSys(0);

 			
}

 					break;
 					
 					case ADDMONEY:	
					//clear it so it is not run again
 					if(triggers[i][0]!=9&&triggers[i][2]!=9)
 					triggers[i][4]=0;
 					money+=triggers[i][5];
	 				break;
 				
 				
 				case LAUNCHSUPER:
 				if(triggers[i][0]!=9&&triggers[i][2]!=9)
 					triggers[i][4]=0;
 					
 				switch(enemyside)
 				{
 					case 0:  if(checkforunit(ACOM,enemyside,-1))  superweapons[0]=IONCHARGE;  break;
 					case 1:  if(checkforunit(TMPL,enemyside,-1))  superweapons[1]=NUKECHARGE;  break;
 				}
 				mapnum=10;
 				break;	
 				
 				
 				case KILLUNIT:
 				if(triggers[i][0]!=9&&triggers[i][2]!=9)
 					triggers[i][4]=0;
 				for(j=0;j<MAX_UNITS+MAX_BUILDINGS;j++)
 				{
 					if(allunits[j].trigger==triggers[i][5]&&allunits[j].x>0)  allunits[j].hp=-1;
 				}
 				killdead=1;
 				
 				break;
 					
 				}
 			}
 			
 		}
 		
		}
 		
 		
 		//goto next order if all units with order are near destination
 		for(i=1;i<MAX_ORDERS;i++)
 		{
 			if(order[i][0]==MOVETO){
 			j=0;
 			for(k=1;k<MAX_UNITS;k++)
 			{
 				if(allunits[k].order==i&&allunits[k].side!=yourside&&allunits[k].x>0)
 				{
 					if(abs(allunits[k].col-order[i][1])>2||abs(allunits[k].row-order[i][2])>2)
 					{
 						j=1;
 						break;
 					}
 					  
 				}
 			}
 			
 			if(j==0)
 			{
 				for(k=1;k<MAX_UNITS;k++)
 				{
 					if(allunits[k].order==i&&allunits[k].side!=yourside&&allunits[k].x>0)
 					{
 						allunits[k].order++;
 								
 					}	
 				}	
 			}
 			
 			}
 			
 		}
 		
 		
 		
 		//teamtypes
 		for(i=1;i<MAX_UNITS;i++)
 		{
 			
 		
 		
 			if(allunits[i].order>0&&allunits[i].side!=yourside&&allunits[i].x>0)
 			{
 					
 				if(order[allunits[i].order][0]==MOVETO&&allunits[i].mode==STOP)
 				{
 						
 					allunits[i].findestcol=order[allunits[i].order][1];
 					allunits[i].findestrow=order[allunits[i].order][2];
 					allunits[i].move=1;
 					allunits[i].mode=MOVE;
 					
 				}
 				
 				if(order[allunits[i].order][0]==GOTOORDER)
 				{
 					allunits[i].order=order[allunits[i].order][1];
 				}
 				
 				if(order[allunits[i].order][0]==ATTACKUNITS&&allunits[i].mode!=ATTACK&&allunits[i].mode!=NEARATTACK)
 				{
 				  //search for closest unit
 					if(closestsearch(&allunits[i].findestcol,&allunits[i].findestrow,yourside,-1)){
 					allunits[i].target=map[allunits[i].findestrow][allunits[i].findestcol];	
 					allunits[i].move=1;
 					allunits[i].mode=ATTACK;
 					}
 					else
 					{  //search for closest building
 						if(closestsearch(&allunits[i].findestcol,&allunits[i].findestrow,yourside,-2)){
 					allunits[i].target=allunits[i].findestrow*100+allunits[i].findestcol+1000;	
 					allunits[i].move=1;
 					allunits[i].mode=ATTACK;
 					}
 					
 						
 					}
 					
 					
 				}
 				
 				
 			}
 			
 		}
 		
 		
 		
 		//set tiberium levels
	maxtiberium=0;
	for(i=MAX_UNITS;i<MAX_UNITS+MAX_BUILDINGS;i++)
	{
		if(allunits[i].x>0&&allunits[i].side==yourside)
		{
			if(allunits[i].type==PROC)  maxtiberium+=2000;
			if(allunits[i].type==SILO)  maxtiberium+=1000;
			
		}
	}
			
	side_a=currenttiberium; 		
	side_b=maxtiberium;
	side_a=side_a/side_b;
	
 	for(i=MAX_UNITS;i<MAX_UNITS+MAX_BUILDINGS;i++)
	{
		if(allunits[i].x>0&&allunits[i].side==yourside)
		{
			if(allunits[i].type==PROC)  allunits[i].store=side_a*23;
 		  if(allunits[i].type==SILO)	allunits[i].store=side_a*15;
		}
	}
		
 	//low on storage space message
 	if(currenttiberium>0&&currenttiberium>maxtiberium-300){
 	for(i=0;i<3;i++)
 	{
 		if(allmessages[i][0]==0) break;
 	}
 	if(i<3)
 	{
 		allmessages[i][0]=1;
 		allmessages[i][1]=1;
 	}
 	}
 		
 		
 		
 		//set power levels
	poweroutput=0;
	powerconsumption=0;
	
	for(i=1;i<MAX_UNITS+MAX_BUILDINGS;i++)
	{


		//enemy repairs buildings with less than 50% hp
		if(allunittypes[allunits[i].type].speed<4&&allunits[i].side!=yourside&&allunits[i].hp*2<allunittypes[allunits[i].type].maxhp)
		{
			allunits[i].repair=1;
		}
		
		
		
		//tell enemy harvester to do something if not
 			if(allunits[i].type==HARV&&allunits[i].mode==STOP&&allunits[i].side!=yourside&&
 			(allunits[map[allunits[i].row-1][allunits[i].col]].type!=PROC||map[allunits[i].row-1][allunits[i].col]<=0))
 			{
 				
 				if(allunits[i].store<7)	{
 				closestsearch(&allunits[i].findestcol,&allunits[i].findestrow,-1,-1);
 			allunits[i].mode=MOVE;
 			}
 			
		if(allunits[i].store==7){
			//search for refinery
			closestsearch(&allunits[i].findestcol,&allunits[i].findestrow,allunits[i].side,PROC);		
 			allunits[i].mode=MOVE;
 			
 			
 			}
 			
 			}
 		
		
		if(allunits[i].x>0&&allunittypes[allunits[i].type].speed<4)
		{
			if(allunits[i].side==yourside){  powerconsumption+=allunittypes[allunits[i].type].powercost;
			if(allunits[i].type==NUKE)  poweroutput+=10;
			if(allunits[i].type==NUK2)  poweroutput+=20;
			
			}
			
			if(allunits[i].side!=yourside){  enemypowerconsumption+=allunittypes[allunits[i].type].powercost;
			if(allunits[i].type==NUKE)  enemypoweroutput+=10;
			if(allunits[i].type==NUK2)  enemypoweroutput+=20;
			
			}
		
		
		}
	}


	
	//slow down production
	if(poweroutput<powerconsumption){
		
	for(j=0;j<3;j++){
	 allbuilders[j].done=allunittypes[allbuilders[j].type].cost;
	}
	}				
	else
	{
	for(j=0;j<3;j++){
	 allbuilders[j].done=allunittypes[allbuilders[j].type].cost/4;
	}
	}


for(k=0;k<3;k++){
j=0;
for(i=MAX_UNITS;i<MAX_UNITS+MAX_BUILDINGS;i++)
{
	if(allunits[i].type==allunittypes[allbuilders[k].type].pre1&&allunits[i].x>0&&allunits[i].side==yourside) j++;
}
if(j!=0)
allbuilders[k].done/=(sqrt(j)+1);
}	
	


 		
ClearGrayScreen2B(sidebarl,sidebard);
 		
  
  PortSet(sidebard,239,99);
  
  //game messages
 		for(i=0;i<3;i++)
 		{
 			if(allmessages[i][0]>0)
 			{
 				allmessages[i][0]--;
 				
 				DrawStr(34,0+i*6,messagetext[allmessages[i][1]],2);
				 
 
 			}
 		}
 		
  

	//super weapons
	switch(yourside)
	{
		case 0:
		if(superweapons[0]>0)
		DrawInt(0,90,superweapons[0]*100/IONCHARGE,0);
		break;
		case 1:
		if(superweapons[1]>0)
		DrawInt(0,90,superweapons[1]*100/NUKECHARGE,0);
		break;
		
	}

	
	if(poweroutput>powerconsumption){
	
	if(checkforunit(COMM,yourside,-1)){
	//border for minimap
	DrawLine(mapwidth/(mapwidth/33+1),0,mapwidth/(mapwidth/33+1),mapheight/(mapheight/33+1),A_XOR);
	DrawLine(0,mapheight/(mapheight/33+1),mapwidth/(mapwidth/33+1)-1,mapheight/(mapheight/33+1),A_XOR);
	}
	
	//marker
	DrawLine(32-32*powerconsumption/poweroutput,43,32-32*powerconsumption/poweroutput,47,A_XOR);
	
	//power bar
	DrawLine(0,44,32,44,A_XOR);
	DrawLine(0,46,32,46,A_XOR);
	
	}
	
	
	if(checkforunit(YARD,yourside,-1))
	DrawClipRect (MakeWinRect (0, 50, 17, 67), &scr_rect, A_XOR);
	
	if((checkforunit(WEAP,yourside,-1)||checkforunit(PYLE,yourside,-1)))
	DrawClipRect (MakeWinRect (0, 70, 17, 87), &scr_rect, A_XOR);
	
	if(allbuilders[0].oldrow==16)
	DrawStr(20,56,"DONE",2);
	
	
	PortSet(sidebarl,239,99);
  
	if(poweroutput>powerconsumption)
	{
	//border of minimap
	if(checkforunit(COMM,yourside,-1)){
	DrawLine(mapwidth/(mapwidth/33+1),0,mapwidth/(mapwidth/33+1),mapheight/(mapheight/33+1),A_XOR);
	DrawLine(0,mapheight/(mapheight/33+1),mapwidth/(mapwidth/33+1)-1,mapheight/(mapheight/33+1),A_XOR);
	}
	
	//middle of power bar
	DrawLine(0,45,32,45,A_XOR);
	
		
	}
	
	
	
	if(checkforunit(YARD,yourside,-1))
	DrawClipRect (MakeWinRect (0, 50, 17, 67), &scr_rect, A_XOR);
	
	if((checkforunit(WEAP,yourside,-1)||checkforunit(PYLE,yourside,-1)))
	DrawClipRect (MakeWinRect (0, 70, 17, 87), &scr_rect, A_XOR);



	

  
  if(poweroutput>powerconsumption&&checkforunit(COMM,yourside,-1)){


  
  //actual dots on minimap
  for(j=0;j<mapheight;j++)
  {
  	for(i=0;i<mapwidth;i++)
  	{
  		
  		if(fog[j][i]!=0)
  		{
				EXT_SETPIX(sidebarl,i/(mapwidth/33+1),j/(mapheight/33+1));  		
			}

  		if(map[j][i]>0){  		
			if(fog[j][i]==0&&*(punits+UNIT_VALUES*map[j][i]+17)!=yourside) 
  		{
  			EXT_SETPIX(sidebard,i/(mapwidth/33+1),j/(mapheight/33+1));
  		}
  		if((fog[j][i]==0&&*(punits+UNIT_VALUES*map[j][i]+17)==yourside)) 
  		{
  			EXT_SETPIX(sidebarl,i/(mapwidth/33+1),j/(mapheight/33+1));
  		}
  		}
  		
  		
  	}
  }
  }
  
 SetPlane(DARK_PLANE);



 	redraw=1;
 		
 	}
 
 
 
 
 
 
 //super weapons
 if(mapnum==10||(_rowread(ARROWS_ROW)&ALPHA_KEY&&_rowread(F5_ROW)&FX_KEY))
{
	


	
	
	
	if(superweapons[0]>=IONCHARGE)
	{
	
	if(yourside==0)
	{
		k=(col+curmapx+8)/16;
		l=(row+curmapy+8)/16;
	}
	else
	{
		k=-1;
		for(i=NUKE;i<TMPL&&k==-1;i++)
		{
			for(j=1;j<MAX_UNITS+MAX_BUILDINGS;j++)
			{
				if(allunits[j].type==i&&allunits[j].side==yourside&&allunits[j].x>0)
				{
					k=allunits[j].col;
					l=allunits[j].row;
					break;
				}
			}
		}
		
	}
	
	
		for(i=(curmapy)/16;i<l;i++)
		{
			GraySprite16(k*16,i*16,superpics,0,0);
		}
		GraySprite16(k*16,l*16,superpics+32,0,0);
	
	for(j=0;j<600;j++)
	{
		for(i=0;i<30000;i++);
	}
	
	if(map[l][k]>0)
	{
		allunits[map[l][k]].hp-=200;
	}
	
	
	superweapons[0]=0;			
			
	}
	


	if(superweapons[1]>=NUKECHARGE)
	{
	
		if(yourside==1)
	{
		k=(col+curmapx+8)/16;
		l=(row+curmapy+8)/16;
	}
	else
	{
		k=-1;
		for(i=NUKE;i<TMPL;i++)
		{
			for(j=1;j<MAX_UNITS+MAX_BUILDINGS;j++)
			{
				if(allunits[j].type==i&&allunits[j].side==yourside&&allunits[j].x>0)
				{
					k=allunits[j].col;
					l=allunits[j].row;
					break;
				}
			}
			if(k>=0) break;
		}
		
	}

		GraySprite16(k*16,l*16,superpics+32*3,0,0);
		GraySprite16(k*16,l*16-16,superpics+32*2,0,0);
	
	for(j=0;j<400;j++)
	{
		for(i=0;i<30000;i++);
	}

	clrgrayscr();
	
		GraySprite16(k*16,l*16,superpics+32*3,0,0);
		GraySprite16(k*16,l*16-16,superpics+32*2,0,0);
	
	for(j=0;j<400;j++)
	{
		for(i=0;i<30000;i++);
	}
	
for(i=1;i<MAX_UNITS+MAX_BUILDINGS;i++)
{
	if(allunits[i].col<k+4&&allunits[i].col>k-4
	&&allunits[i].row<l+4&&allunits[i].row>l-4)
	{
		allunits[i].hp-=totaldamage(200,2,allunittypes[allunits[i].type].armortype);		
	}
}
	
	
	superweapons[1]=0;			
			
	}
	
	killdead=1;	
	
	redraw=1;
}	
 

 	
  
  key=_rowread(ARROWS_ROW);
  

	
	
	
	//move cursor	
	if(key&LEFT_KEY&&col>0)
	{
		col-=mousespeed;
			
	}
	 
	if(key&RIGHT_KEY&&col<160-16)
	{
		col+=mousespeed;
			
	}
	 
	if(key&UP_KEY&&row>0)
	{
		row-=mousespeed;
			
	}
	 
	if(key&DOWN_KEY&&row<100-16)
	{
		row+=mousespeed;
			
	}
	
	if(row>84) row=84;
	if(row<0) row=0;
	if(col<0) col=0;
	if(col>144) col=144;
	
	
	//select box 
	if(selectbox[0]>=0&&(oldcol!=col||oldrow!=row))
	{
		GrayRect(selectbox[0]-curmapx,selectbox[1]-curmapy,selectbox[2]-curmapx,selectbox[3]-curmapy,0);
		selectbox[2]=col+8+curmapx;
		selectbox[3]=row+8+curmapy;
		GrayRect(selectbox[0]-curmapx,selectbox[1]-curmapy,selectbox[2]-curmapx,selectbox[3]-curmapy,0);
		
		
	}


	
	
	//scrolling
	if(arrow>=5)
	{
	
	CursorSprite16(arrowx,arrowy,cursor+32*arrow,0);			
	
	arrow=0;
	ministart=-10;
	}	
	
	//left
	if(col==0&&curmapx>0&&key&LEFT_KEY)
	{
		arrow=8;
		  curmapx-=scrollspeed;
	}
	//right
	if(col==160-16&&curmapx<mapwidth*16-160&&key&RIGHT_KEY)
	{
		arrow=6;
		  curmapx+=scrollspeed;
	}
	//up
	if(row==0&&curmapy>0&&key&UP_KEY)
	{
		arrow=5;
		  curmapy-=scrollspeed;
	}
	//down
	if(row==100-16&&curmapy<mapheight*16-100&&key&DOWN_KEY)
	{
		arrow=7;
		  curmapy+=scrollspeed;
	}
	
	//redraw map
	if(arrow>=5)  
	{
	
		if(curmapx>mapwidth*16-160) curmapx=mapwidth*16-160;	
		if(curmapx<0) curmapx=0;	
		if(curmapy>mapheight*16-100) curmapy=mapheight*16-100;	
		if(curmapy<0) curmapy=0;	
	
		drawmap();
		
		ministart=10;
 	
		
		CursorSprite16(col,row,cursor+32*arrow,0);			
	
		oldcol=160;
		oldrow=100;
		arrowx=col;
		arrowy=row;
			
  }
	
	//}while(arrow>=5);
	
	
	
	
	if(curset<10){
	
	
	for(mapnum=1;mapnum<MAX_UNITS+MAX_BUILDINGS;mapnum++)
	{
	if(allunits[mapnum].select==1)  break;
	}
	
	
	
	//Puts select box on current unit, if there is one
	if(map[(row+8+curmapy)/16][(col+8+curmapx)/16]>0&&curset==0&&fog[(row+8+curmapy)/16][(col+8+curmapx)/16]
	==0) curset=1;
	
	//back to arrow cursor
	if(map[(row+8+curmapy)/16][(col+8+curmapx)/16]==0&&(curset==1||
	allunits[mapnum].side!=yourside||mapnum>=MAX_UNITS)) curset=0;	
	
	
	//attack to move cursor
	if(curset==3&&(map[(row+8+curmapy)/16][(col+8+curmapx)/16]==0||allunits[map[(row+8+curmapy)/16][(col+8+curmapx)/16]].side==yourside)) curset=2;
	
	//attack cursor
	if(curset==2&&((allunits[mapnum].type!=HARV&&map[(row+8+curmapy)/16][(col+8+curmapx)/16]>0&&fog[(row+8+curmapy)/16][(col+8+curmapx)/16]
	==0&&(allunits[map[(row+8+curmapy)/16][(col+8+curmapx)/16]].side!=yourside))||(allunits[mapnum].type==HARV&&tmap[(row+8+curmapy)/16][(col+8+curmapx)/16]>0&&fog[(row+8+curmapy)/16][(col+8+curmapx)/16]
	==0))) curset=3;
	
	
	
	}
	
	
	//Diamond key
	if(key&DIAMOND_KEY) diamond_hold=1;
	
	if((!(key&DIAMOND_KEY))&&diamond_hold==1) {
	if(curset>1){
	curset=0;
	}
	
	for(mapnum=1;mapnum<MAX_UNITS+MAX_BUILDINGS;mapnum++)
	{
	if(allunits[mapnum].select==1){
	
	drawhealth(allunits[mapnum].x-8,allunits[mapnum].y-8,allunits[mapnum].hp,
	allunittypes[allunits[mapnum].type].maxhp,allunittypes[allunits[mapnum].type].speed,allunits[mapnum].store,allunittypes[allunits[mapnum].type].maxstore);	
	
	allunits[mapnum].select=0;
	}
	}
	
	

	diamond_hold=0;
	}
	
	
	//Second key
	if(key&SECOND_KEY)
	{ 
		second_hold=1;
		if(selectbox[0]<0){
		selectbox[0]=col+8+curmapx;
		selectbox[1]=row+8+curmapy;
		selectbox[2]=col+8+curmapx;
		selectbox[3]=row+8+curmapy;
		GrayRect(selectbox[0]-curmapx,selectbox[1]-curmapy,selectbox[2]-curmapx,selectbox[3]-curmapy,0);
		
		}
	}
	
	//when you let go of the second key
	if((!(key&SECOND_KEY))&&second_hold==1) {
	
	
	switch (curset) {
		
		
	//select unit
	case 0:
	case 1: 
	
	
	//unselect units that are selected
	for(mapnum=1;mapnum<MAX_UNITS+MAX_BUILDINGS;mapnum++)
	{
	
	if(allunits[mapnum].select==1){
	drawhealth(allunits[mapnum].x-8,allunits[mapnum].y-8,allunits[mapnum].hp,
	allunittypes[allunits[mapnum].type].maxhp,allunittypes[allunits[mapnum].type].speed,allunits[mapnum].store,allunittypes[allunits[mapnum].type].maxstore);	
	
	allunits[mapnum].select=0;
	}
	
	
	}
	 	
	
	//adjust for when start is greater than end
	if(selectbox[1]>selectbox[3])
	{
		i=selectbox[1];
		selectbox[1]=selectbox[3];
		selectbox[3]=i;
	}
	
	if(selectbox[0]>selectbox[2])
	{
		i=selectbox[0];
		selectbox[0]=selectbox[2];
		selectbox[2]=i;
	}
	
	
	mapnum=0;
	for(j=selectbox[1]/16;j<=selectbox[3]/16;j++)
	{
		for(i=selectbox[0]/16;i<=selectbox[2]/16;i++)
		{
			if(map[j][i]>0&&allunits[map[j][i]].side==yourside)
			{
				allunits[map[j][i]].select=1;
				mapnum=1;	
			}
			
		}
	}
	
	
	
	
	if(mapnum==0)
	{
		for(j=selectbox[1]/16;j<=selectbox[3]/16;j++)
	{
		for(i=selectbox[0]/16;i<=selectbox[2]/16;i++)
		{
			if(map[j][i]>0&&allunits[map[j][i]].side!=yourside)
				allunits[map[j][i]].select=1;
			
		}
	}	
	}
	
	
	
	for(mapnum=1;mapnum<MAX_UNITS+MAX_BUILDINGS;mapnum++)
	{
	
		if(allunits[mapnum].select==1) 
		{
			
		drawhealth(allunits[mapnum].x-8,allunits[mapnum].y-8,allunits[mapnum].hp,
		allunittypes[allunits[mapnum].type].maxhp,allunittypes[allunits[mapnum].type].speed,allunits[mapnum].store,allunittypes[allunits[mapnum].type].maxstore);	
		if(allunits[mapnum].side==yourside&&mapnum<MAX_UNITS)  curset=2;
	
		}
		
	}
	
	
	
	break;
	
	
	
	//move unit
	case 2: 
	
	for(mapnum=1;mapnum<MAX_UNITS;mapnum++)
	{
	if(allunits[mapnum].select==1&&allunittypes[allunits[mapnum].type].speed>0){
	
	
	//deploy MCV
	if(allunits[mapnum].type==MCV&&allunits[mapnum].col==(col+8+curmapx)/16&&allunits[mapnum].row==(row+8+curmapy)/16)
	{
	
	map[allunits[mapnum].row][allunits[mapnum].col]=0;
	
	k=0;
	l=0;
	for(j=0;j<2;j++)
	{
		for(i=0;i<3;i++)
		{
			if(map[allunits[mapnum].row+j][allunits[mapnum].col+i]==0)
			{
			GraySprite16((allunits[mapnum].col+i)*16,(allunits[mapnum].row+j)*16,pics+32*(allunittypes[YARD].pic+k),0,yourside);
			k++;
			}
			else l=1;
		}
	}
	
	if(l==0)
	{
	
	allunits[mapnum].x=-1;
	allunits[mapnum].col=-1;	
	allunits[mapnum].order=0;
	allunits[mapnum].step=0;
	
	//for standard buildings
 		for(i=MAX_UNITS;i<MAX_UNITS+MAX_BUILDINGS;i++)
 	{
 		if(allunits[i].col<0) break;
 	}
 	
	j=0;
	if(!checkforunit(YARD,yourside,-1))
	j=1;
	
 	
 	creatingunit(i,(row+curmapy+8)/16,(col+curmapx+8)/16,225,yourside,YARD,allunittypes[YARD].maxhp);
  
	if(j==1) {	
	allbuilders[0].type=searchfornext(allbuilders[0].type,1,0);
	inview[0]=allbuilders[0].type;
}


	
  drawbuilding((col+curmapx+8)/16*16,(row+curmapy+8)/16*16,allunittypes[allbuilders[0].type].speed,
	allunittypes[allbuilders[0].type].rotate,allunittypes[allbuilders[0].type].pic,1,yourside,0);	
	
	
			placebuilding(i);
  
 	
 		
	}
	else
	map[allunits[mapnum].row][allunits[mapnum].col]=mapnum;
	
	
	}
	
	
	allunits[mapnum].findestrow=(row+8+curmapy)/16;
	allunits[mapnum].findestcol=(col+8+curmapx)/16;
	allunits[mapnum].mode=MOVE;
	allunits[mapnum].move=1;
	}
	}
	
	break;	
	
	//attack mode
	case 3:
	//set target
	
	for(mapnum=1;mapnum<MAX_UNITS;mapnum++)
	{
	if(allunits[mapnum].select==1){
	
	
	if(allunits[mapnum].type!=HARV&&(allunits[mapnum].type!=COMMANDO||allunittypes[allunits[map[(row+8+curmapy)/16][(col+8+curmapx)/16]].type].speed>3)){
		
	//for units
	if(allunits[mapnum].type!=ENGINEER&&map[(row+8+curmapy)/16][(col+8+curmapx)/16]<MAX_UNITS) allunits[mapnum].target=map[(row+8+curmapy)/16][(col+8+curmapx)/16];
	//for buildings and empty space
	else {allunits[mapnum].target=(row+8+curmapy)/16*100+((col+8+curmapx)/16)+1000;
		}
	
	
		
	allunits[mapnum].mode=ATTACK;

	
	}
	
	//harvester moves to tiberium or commando targets building
	else
	{
		allunits[mapnum].findestrow=(row+8+curmapy)/16;
		allunits[mapnum].findestcol=(col+8+curmapx)/16;
		allunits[mapnum].mode=MOVE;
		allunits[mapnum].move=1;	
	}
	
	
	//change cooldown so unit rotates berfore firing
	allunits[mapnum].curcool-=2;
	
	
	}
	}
	
	break;
	
	
	
	}
	GrayRect(selectbox[0]-curmapx,selectbox[1]-curmapy,selectbox[2]-curmapx,selectbox[3]-curmapy,0);	
	selectbox[0]=-1;	
	second_hold=0;

  }
	
	

if(_rowread(ARROWS_ROW)&SHIFT_KEY&&_rowread(HOME_ROW)&HOME_KEY)
{	
	clrgrayscr();

	GrayOff();
	SetIntVec (AUTO_INT_1, save_int_1);

	FontSetSys(1);
	
	DrawStr(10,0,"F1 : Save",4);
	DrawStr(10,10,"F2 : Save & Exit",4);
	DrawStr(10,20,"F4 : Restart Level",4);
	DrawStr(10,30,"F5 : Exit",4);
	DrawStr(10,45,"0 : Turn off Calc",4);
	
	DrawStr(10,60,"5 : Mouse Speed",4);
	DrawInt(106,60,mousespeed,1);
	
	DrawStr(0,70,"+ or -",4);
	DrawStr(100,70,"* or /",4);
	
	
	DrawStr(100,80,"GAMESPEED",2);
	DrawInt(100,90,gamespeed,1);

	DrawStr(0,80,"SCROLLSPEED",2);
	DrawInt(0,90,scrollspeed,1);
  


	j=0;
	
	while(j==0&&exit==0&&(i=ngetchx())!=KEY_ESC)
	{

	if(i==KEY_F4) j=2;

	if(i=='0') off();
	
	
	if(i==KEY_F2)
	{
		j=1;
		sprintf(savename,"ctc2save");
		exit=1;
	}

	if(i==KEY_F5)
	{
		exit=1;
	}
	
	if(i==KEY_F1)	
		//save as another name
	{
		
		if(strcmp(savename,"ctc2save")==0)
		sprintf(savename,"");
		
		clrscr();
		DrawStr(47,30,"SAVE NAME?",2);
		InputStr(55,50,savename,8);
		
		j=1;		
		
	}

	
	DrawInt(106,60,mousespeed,1);
	
	if(i=='5')
	{
		switch(mousespeed)
		{
			case 1: mousespeed=2; break;
			case 2: mousespeed=1; break;
		}
	}
	
	DrawInt(106,60,mousespeed,1);
	
	
	DrawInt(0,90,scrollspeed,1);
  
		if(i==43&&scrollspeed<16)  //PLUS
		{
			scrollspeed++;
		}

		
		if(i==45&&scrollspeed>0)  //MINUS
		{
			scrollspeed--;
		}
		

	DrawInt(0,90,scrollspeed,1);
  
  	
			DrawInt(100,90,gamespeed,1);

		
		if(i==42&&gamespeed<0xFF)  //TIMES
		{
			gamespeed++;
		}
		
		if(i==47&&gamespeed>0)  //DIVIDE
		{
			gamespeed--;
		}


			DrawInt(100,90,gamespeed,1);

		
	}
	

if(j==1){
	
clrscr();

if(strcmp(savename,"")==0)  sprintf(savename,"ctc2save");

DrawStr(23,30,"Saving to",4);
DrawStr(83,30,savename,4);

DrawStr(23,60,"Thanks for playing!",4);
DrawStr(23,70,"Send comments to...",4);
DrawStr(30,85,"tnt@calcware.org",4);


	TIOSname[0] = 0;	

	hsym = SymFind (strcpy (TIOSname + 1, savename) + strlen (savename));

	EM_moveSymFromExtMem (NULL, hsym); 


//	HSymDel (hsym);

	
	if((f=fopen(savename,"w+b")))
	{
		
	
	//find the last unit active to reduce file size
	
	for(k=MAX_UNITS-1;k>1;k--)
	{
		if(allunits[k].x>0) break;
	}
	k++;
	
	fwrite(&k,2,1,f);
	fwrite(&allunits[0].col,2,UNIT_VALUES*k,f);
	
	
	for(k=MAX_UNITS+MAX_BUILDINGS-1;k>MAX_UNITS;k--)
	{
		if(allunits[k].x>0) break;
	}
	k++;
	
	k-=MAX_UNITS;
	fwrite(&k,2,1,f);
	fwrite(&allunits[MAX_UNITS].col,2,UNIT_VALUES*k,f);

	
	
	
	fwrite(&allbullets[0].on,2,BULLET_VALUES*MAX_BULLETS,f);
	fwrite(&allexplosions[0].time,2,4*MAX_EXPLOSIONS,f);
	fwrite(&levelname,1,10,f);
	fwrite(&curmapx,2,1,f);
	fwrite(&curmapy,2,1,f);
	fwrite(&mapwidth,2,1,f);
	fwrite(&mapheight,2,1,f);
	fwrite(&allbuilders[0].y,2,5*3,f);
	

k=0;
	//terrain  y*100+x so x and y are one var, to save space

for(m=0;m<4;m++){
	for(j=0;j<mapheight;j++)
	{
		for(i=0;i<mapwidth;i++)
		{
			if(map[j][i]<0&&m<2)
			{
				if(m==0) k++;
				else
				{
					l=j*100+i;
					fwrite(&l,2,1,f);
					moveorder[0]=map[j][i];
					fwrite(&moveorder[0],1,1,f);
				}
			}
			
			if(tmap[j][i]>6&&m>1)
			{
				if(m==2) k++;
				else
				{
					l=j*100+i;
					fwrite(&l,2,1,f);
					fwrite(&tmap[j][i],1,1,f);
				}
			}
			
		}
	}
	
	if(m==0)
	{
	fwrite(&k,2,1,f);
	k=0;
	}	
	if(m==2) fwrite(&k,2,1,f);
		
}
	
	
	for(j=0;j<mapheight;j++){
	fwrite(&fog[j][0],1,mapwidth,f);
	}
	
	fwrite(&yourside,2,1,f);
	fwrite(&enemyside,2,1,f);
	fwrite(&money,2,1,f);
	fwrite(&powerconsumption,2,1,f);
	fwrite(&poweroutput,2,1,f);
	fwrite(&enemymoney,2,1,f);
	fwrite(&enemypowerconsumption,2,1,f);
	fwrite(&enemypoweroutput,2,1,f);
	fwrite(&row,2,1,f);
	fwrite(&col,2,1,f);
	fwrite(&oldrow,2,1,f);
	fwrite(&oldcol,2,1,f);
	fwrite(&curset,2,1,f);
	fwrite(&oldcurset,2,1,f);
	fwrite(&scrollspeed,2,1,f);
	fwrite(&gamespeed,2,1,f);
	fwrite(&tiberiumgrowthtimer,2,1,f);
	fwrite(&enemybuilder[0],2,4,f);
	fwrite(&enemybuildque[0],2,3,f);
	fwrite(&teams[0][0],2,110,f);
	fwrite(&order[0][0],2,MAX_ORDERS*3,f);
	fwrite(&triggers[0][0],2,MAX_TRIGGERS*6,f);
	fwrite(&maxtiberium,2,1,f);
	fwrite(&currenttiberium,2,1,f);
	fwrite(&warning,2,4,f);
	fwrite(&selectbox,2,4,f);
	fwrite(&enemytobuild[0][0],2,MAX_TOBUILDS*3,f);
	fwrite(&techlevel,2,1,f);
	fwrite(&allowvictory,2,1,f);
	fwrite(&allmessages,2,6,f);
	fwrite(&superweapons,2,2,f);
	fwrite(&inview,2,2,f);
	fwrite(&mousespeed,2,1,f);
	fwrite(&gametimer,2,1,f);

	
	fputc(0,f);
	fputs("ctc2",f);
	fputc(0,f);

	fputc(OTH_TAG,f);

	fclose(f);	
	
	
	
	
	
	}
	

	
	if(strcmp(savename,"ctc2save")!=0)
	{
		hsym = SymFind (strcpy (TIOSname + 1, savename) + strlen (savename));
		EM_moveSymToExtMem (NULL, hsym); 
	}

j=1;
}


  		poke(0x600017,gamespeed);      // Force timer to work faster

SetIntVec (AUTO_INT_1, DUMMY_HANDLER);   // redirect auto-int 1 to "nothing"
GrayOn();

FontSetSys(0);

if(j==2)	goto startover;
	
 	redraw=1;
}

  
  
  
  
	
    
  
  //move bullets
  for(bulletnum=1;bulletnum<MAX_BULLETS;bulletnum++)
  
  
  if(allbullets[bulletnum].on>0)
  {
  	allbullets[bulletnum].curspeed-=allbullets[bulletnum].speed;
  	if(allbullets[bulletnum].curspeed<=0)
  	{
  		allbullets[bulletnum].curspeed+=100;
			
			
			//removes picture of bullet
			if(allbullets[bulletnum].on>1)
			GraySprite8(allbullets[bulletnum].startx+(allbullets[bulletnum].on*
			allbullets[bulletnum].a/allbullets[bulletnum].c)-4,allbullets[bulletnum].starty+(allbullets[bulletnum]
			.on*allbullets[bulletnum].b/allbullets[bulletnum].c)-4,8,shell+16*allbullets[bulletnum].bulletpic); 
			
			allbullets[bulletnum].on+=1+(allbullets[bulletnum].speed-1)/100;
			
			
			//expolsoion if at destination
			if(allbullets[bulletnum].on>allbullets[bulletnum].c)
			{
				allbullets[bulletnum].on=0;
				
				//checkstall+=6;
				
				//explosion
						for(j=0;j<MAX_EXPLOSIONS;j++)
						{
							if(allexplosions[j].time==0) break;
						}
						allexplosions[j].explodetype=allwarheads[allbullets[bulletnum].wartype].explosionpic;			
						allexplosions[j].time=200;
						allexplosions[j].x=allbullets[bulletnum].endx-8;
						allexplosions[j].y=allbullets[bulletnum].endy-8;
						GraySprite16(allexplosions[j].x,allexplosions[j].y,explode+32*(allexplosions[j].explodetype),0,0);
				
				
				if(allbullets[bulletnum].wartype==LASER)
				{
					//explosion
						for(j=0;j<MAX_EXPLOSIONS;j++)
						{
							if(allexplosions[j].time==0) break;
						}
						allexplosions[j].explodetype=allbullets[bulletnum].starty/16*100+allbullets[bulletnum].startx/16+1000;			
						allexplosions[j].time=100;
						allexplosions[j].x=allbullets[bulletnum].endx;
						allexplosions[j].y=allbullets[bulletnum].endy;
						  	GrayLine(checkline(((allexplosions[j].explodetype-1000)-(allexplosions[j].explodetype-1000)/100*100)*16+8-curmapx,159),
			checkline((allexplosions[j].explodetype-1000)/100*16-curmapy,99),checkline(allexplosions[j].x-curmapx,159),checkline(allexplosions[j].y-curmapy,99),1);
				}
				
				
				//search for targets in range of explosion
				for(i=1;i<MAX_UNITS+MAX_BUILDINGS;i++)
				{
					
					if(allunits[i].x>0&&abs(allunits[i].x-allbullets[bulletnum].endx)<48&&
					abs(allunits[i].y-allbullets[bulletnum].endy)<48){ //if unit is active and near explosion
						
					
					
						
					
					//distance formula
					if((sqrt(square(allunits[i].x-allbullets[bulletnum].endx)+square(allunits[i].y-allbullets[bulletnum].endy))
					<=allwarheads[allbullets[bulletnum].wartype].spread)||
					(i>=MAX_UNITS&&map[allbullets[bulletnum].endy/16][allbullets[bulletnum].endx/16]==i))  //for buildings
					{
						
						//change hp mark if selected
						if(allunits[i].select==1) 
						drawhealth(allunits[i].x-8,allunits[i].y-8,allunits[i].hp,allunittypes[allunits[i].type].maxhp
						,allunittypes[allunits[mapnum].type].speed,allunits[mapnum].store,allunittypes[allunits[mapnum].type].maxstore);	
	
						if(i<MAX_UNITS){  //units
						//damage based on distance from explosion
						j=sqrt(square(allunits[i].x-allbullets[bulletnum].endx)+square(allunits[i]
						.y-allbullets[bulletnum].endy))/(-1)+
						totaldamage(allwarheads[allbullets[bulletnum].wartype].damage,allwarheads[allbullets[bulletnum]
						.wartype].damagetype,allunittypes[allunits[i].type].armortype);
						
						}
						else  //buildings
						{
						j=totaldamage(allwarheads[allbullets[bulletnum].wartype].damage,allwarheads[allbullets[bulletnum]
						.wartype].damagetype,allunittypes[allunits[i].type].armortype);
						
						}
						
						if(j<1) j=1;
						
						allunits[i].hp-=j;
						
						
						//warning on minimap
						if(warning[0]<2&&allunits[i].side==yourside)
						{
							warning[0]=10;
							warning[1]=25;
							warning[2]=allunits[i].x/16;
							warning[3]=allunits[i].y/16;			
							
							if(poweroutput>powerconsumption&&checkforunit(COMM,yourside,-1))
							GrayRect(warning[2]-warning[0]/2,warning[3]-warning[0]/2,
							warning[2]+warning[0]/2,warning[3]+warning[0]/2,1);
						}
						
						
	//unit under attack				
	if(allunits[i].side==yourside){
 	for(j=0;j<3;j++)
 	{
 		if(allmessages[j][0]>0&&allmessages[j][1]==0)
 		{
 			j=3;
 			break;
 		}
 		if(allmessages[j][0]==0) break;
 	}
 	if(j<3)
 	{
 		allmessages[j][0]=2;
 		allmessages[j][1]=0;
 	}
 	}
 	
if(allunits[i].hp<0)
killdead=1;						
						
						
						
						
						
						
						
						
						//hp marker changed
						if(allunits[i].select==1) 
						drawhealth(allunits[i].x-8,allunits[i].y-8,allunits[i].hp,allunittypes[allunits[i].type].maxhp
						,allunittypes[allunits[mapnum].type].speed,allunits[mapnum].store,allunittypes[allunits[mapnum].type].maxstore);	
					
					}
						
					}
					
				}
				
				
			}
			
			//places picture of bullet
			else
			{
			GraySprite8(allbullets[bulletnum].startx+(allbullets[bulletnum].on*allbullets[bulletnum].a/
			allbullets[bulletnum].c)-4,allbullets[bulletnum].starty+(allbullets[bulletnum].on*allbullets[bulletnum]
			.b/allbullets[bulletnum].c)-4,8,shell+16*allbullets[bulletnum].bulletpic);
			}
				 
  		
  	}
  	
  }
  
  
 
  //explosions
  for(j=0;j<MAX_EXPLOSIONS;j++)
  {
  	if(allexplosions[j].explodetype>=1000&&allexplosions[j].time==1)
  	GrayLine(checkline(((allexplosions[j].explodetype-1000)-(allexplosions[j].explodetype-1000)/100*100)*16+8-curmapx,159),
			checkline((allexplosions[j].explodetype-1000)/100*16-curmapy,99),checkline(allexplosions[j].x-curmapx,159),checkline(allexplosions[j].y-curmapy,99),1);
  	
  	
  	if(allexplosions[j].time>0)
  	{
  		allexplosions[j].time--;
  		
  		if(allexplosions[j].explodetype<1000&&(allexplosions[j].time==150||allexplosions[j].time==20||allexplosions[j].time==0)){
  		//change explode pic
  		
  		GraySprite16(allexplosions[j].x,allexplosions[j].y,explode+32*allexplosions[j].explodetype,0,0);
  		
  		if(allexplosions[j].time==150) allexplosions[j].explodetype++;
  		if(allexplosions[j].time==20) allexplosions[j].explodetype--;
  		
  		
  		if(allexplosions[j].time>0)
  		
  		GraySprite16(allexplosions[j].x,allexplosions[j].y,explode+32*allexplosions[j].explodetype,0,0);
  		}
  		
  	}
  	 
  }
  
   
  


  
// removes dead units  
if(killdead==1){
  for(i=1;i<MAX_UNITS+MAX_BUILDINGS;i++)
  {
  					killdead=0;
  
  							//dead
						if(allunits[i].hp<=0&&allunits[i].x>0)
						{
						

 	if(allunits[i].select==1)
 	drawhealth(allunits[i].x-8,allunits[i].y-8,allunits[i].hp,allunittypes[allunits[i].type].maxhp,
 	allunittypes[allunits[i].type].speed,allunits[i].store,allunittypes[allunits[i].type].maxstore);	
	
	if(allunits[i].side!=yourside)  putbadmark(allunits[i].x,allunits[i].y);
	if(allunittypes[allunits[i].type].rotate>25)  puticonmark(allunits[i].x,allunits[i].y,allunittypes[allunits[i].type].icon);

						//lose money if silo destroyed
						if(allunits[i].type==SILO)
						{
							if(allunits[i].side==yourside)
							money-=66*allunits[i].store;
							else
							enemymoney-=66*allunits[i].store;
						}
						
						//or if refinery
						if(allunits[i].type==PROC&&allunits[i].side==yourside)
						{
						if(allunits[i].side==yourside)
						money-=87*allunits[i].store;
						else
						enemymoney-=87*allunits[i].store;
						}
						
						if(allunits[i].hp<0){		
							//explosion
						for(j=0;j<MAX_EXPLOSIONS;j++)
						{
							if(allexplosions[j].time==0) break;
						}
						allexplosions[j].explodetype=0;			
						allexplosions[j].time=200;
						allexplosions[j].x=allunits[i].x-8;
						allexplosions[j].y=allunits[i].y-8;
						GraySprite16(allexplosions[j].x,allexplosions[j].y,explode+32*allexplosions[j].explodetype,0,0);
				}
						
						
						
						if(i<MAX_UNITS){
						GraySprite16(allunits[i].x-8,allunits[i].y-8,pics+32*(allunittypes[allunits[i].type].pic+(allunits[i].direction)/450+allunits[i].step),0,allunits[i].side);
						}

						
						
						//erase all squares on map with this unit
						for(j=0;j<mapheight;j++)
						{
							for(k=0;k<mapwidth;k++)
							{
								if(map[j][k]==i)  map[j][k]=0;
							}
						}
						
						//tell other units with this target, it is dead
						for(j=1;j<MAX_UNITS;j++)
						{
							if((i<MAX_UNITS&&allunits[j].target==i))
							{
								allunits[j].mode=STOP;
								allunits[j].target=0;
							}
							if(i>=MAX_UNITS){
						
							for(k=allunits[i].row;k<allunits[i].row+allunittypes[allunits[i].side].rotate;k++)
							{
								for(l=allunits[i].col;l<allunits[i].col+allunittypes[allunits[i].side].speed;l++)
								{
						
								if(allunits[j].target==k*100+l+1000)
							    {
								  allunits[j].mode=STOP;
								  allunits[j].target=0;
							    }

								}
							
							}
							
							}
							
							
							
							
						}
						
						allunits[i].x=-1;
						allunits[i].col=-1;	
						allunits[i].order=0;
						allunits[i].step=0;
						
						
						}

  }
  }
  
   
  
  
  
  //units
  for(unitnum=1;unitnum<MAX_UNITS;unitnum++)
  {
  
  if(allunits[unitnum].x>=0)
  {
  
  
  //cooldown for weapons  ;  oblisk and adv tower don't work in low power
  if(allunits[unitnum].curcool<allwarheads[allunittypes[allunits[unitnum].type].wartype].cooldown
  &&((allunits[unitnum].type!=OBLI&&allunits[unitnum].type!=ATWR)||((allunits[unitnum].side==yourside&&poweroutput>=powerconsumption)||(allunits[unitnum].side!=yourside&&enemypoweroutput>=enemypowerconsumption))))  
  allunits[unitnum].curcool++;
	
	//harvester dumps tiberium
	if(allunits[unitnum].curcool>=allwarheads[allunittypes[allunits[unitnum].type].wartype].cooldown&&allunits[map[allunits[unitnum].row-1][allunits[unitnum].col]].type==PROC&&allunits[unitnum].store>0&&
	abs(allunits[unitnum].direction-allunits[unitnum].destdir)<=allunittypes[allunits[unitnum].type].rotate&&allunits[unitnum].mode==STOP)
		{
		
			//if selected change boxes
			if(allunits[unitnum].select==1) { 		
 	drawhealth(allunits[unitnum].x-8,allunits[unitnum].y-8,allunits[unitnum].hp,
 	allunittypes[allunits[unitnum].type].maxhp,allunittypes[allunits[unitnum].type].speed,allunits[unitnum].store,allunittypes[allunits[unitnum].type].maxstore);	
	
	}

			if(allunits[unitnum].side==yourside)
			{
				DrawInt(0,35,money,0);
			if(currenttiberium<maxtiberium){ money+=100;
			currenttiberium+=100;}
			DrawInt(0,35,money,0);	
			}
			else enemymoney+=100;
			
			
			allunits[unitnum].store--;
			allunits[unitnum].curcool=250;
			
			
		if(allunits[unitnum].select==1) { 		
 	drawhealth(allunits[unitnum].x-8,allunits[unitnum].y-8,allunits[unitnum].hp,
 	allunittypes[allunits[unitnum].type].maxhp,allunittypes[allunits[unitnum].type].speed,allunits[unitnum].store,allunittypes[allunits[unitnum].type].maxstore);	
	
	}

			if(allunits[unitnum].store==0){
			closestsearch(&allunits[unitnum].findestcol,&allunits[unitnum].findestrow,-1,-1);
			allunits[unitnum].move=1;
			allunits[unitnum].mode=MOVE;
			}
	
	}
	
	
	//harvester gets tiberium
	if(allunits[unitnum].type==HARV&&allunits[unitnum].curcool>=allwarheads[allunittypes[allunits[unitnum].type].wartype].cooldown&&allunits[unitnum].mode==HARVEST&&allunits[unitnum].store<7)
	{
	
	
		
		allunits[unitnum].store++;
		
		tmap[allunits[unitnum].row][allunits[unitnum].col]--;
		
		if(tmap[allunits[unitnum].row][allunits[unitnum].col]<8){
		tmap[allunits[unitnum].row][allunits[unitnum].col]=0;
		
		if(allunits[unitnum].store<7){  closestsearch(&allunits[unitnum].findestcol,&allunits[unitnum].findestrow,-1,-1);
		}
			
		}
		
	
		
		allunits[unitnum].curcool=0;
		
		if(allunits[unitnum].store==7)
		{
			//search for refinery
			closestsearch(&allunits[unitnum].findestcol,&allunits[unitnum].findestrow,allunits[unitnum].side,PROC);
			
				
		}
	redraw=1;	

		
	}




	
	  
  //rotates unit
	if(abs(allunits[unitnum].direction-allunits[unitnum].destdir)>allunittypes[allunits[unitnum].type].rotate
	&&allunits[unitnum].move==0)
	{
  	temp=allunits[unitnum].direction-allunits[unitnum].destdir;
  	temp1=allunits[unitnum].destdir-allunits[unitnum].direction;
  	if(temp<0) temp+=3600;
  	if(temp1<0) temp1+=3600;
  	
  	
  	if(temp<=temp1) allunits[unitnum].direction-=allunittypes[allunits[unitnum].type].rotate;
  	else allunits[unitnum].direction+=allunittypes[allunits[unitnum].type].rotate;
  	
  	if(allunits[unitnum].direction<0) allunits[unitnum].direction+=3600;
  	if(allunits[unitnum].direction>=3600) allunits[unitnum].direction-=3600;
  	
  	if((allunits[unitnum].olddir)/450!=abs(allunits[unitnum].direction/450))
  	{
  	
  	
  	GraySprite16(allunits[unitnum].x-8,allunits[unitnum].y-8,pics+32*(allunittypes[allunits[unitnum].type].pic+(allunits[unitnum].olddir)/450+allunits[unitnum].step),0,allunits[unitnum].side);
  	allunits[unitnum].step=0;
  	if(allunits[unitnum].type==TOWR||allunits[unitnum].type==ATWR||allunits[unitnum].type==OBLI)
  	{
  		allunits[unitnum].step=(-1)*allunits[unitnum].direction/450;
  	}
  	
  	
  	GraySprite16(allunits[unitnum].x-8,allunits[unitnum].y-8,pics+32*(allunittypes[allunits[unitnum].type].pic+(allunits[unitnum].direction)/450+allunits[unitnum].step),0,allunits[unitnum].side);
  	
  	}
  	
  	allunits[unitnum].olddir=allunits[unitnum].direction;
  	allunits[unitnum].curcool-=2;
  }		
  
  
	
	
	//sets destination for unit depending on whether unit is in range
  if(allunits[unitnum].curcool>=allwarheads[allunittypes[allunits[unitnum].type].wartype].cooldown)
  {
  	
  	
  	//searches for target
  	if(allunits[unitnum].mode!=NEARATTACK&&allunits[unitnum].mode!=ATTACK&&(allunits[unitnum].mode!=MOVE||allunits[unitnum].side!=yourside)&&allunits[unitnum].type!=HARV)
  	{
  		for(i=1;i<MAX_UNITS+MAX_BUILDINGS;i++)
  		{
  			
  			if(allunits[i].x>0&&allunits[unitnum].side!=allunits[i].side){
  			if(abs(allunits[unitnum].x-allunits[i].x)<=allwarheads[allunittypes[allunits[unitnum].type].wartype
  			].range&&abs(allunits[unitnum].y-allunits[i].y)<=allwarheads[allunittypes[allunits[unitnum].type].wartype].range
  			){
  			
  			side_a=allunits[unitnum].x-allunits[i].x;
  			side_b=allunits[unitnum].y-allunits[i].y;
  			
  			if(sqrt(side_a*side_a+side_b*side_b)<allwarheads[allunittypes[allunits[unitnum].type].wartype].range)
  			{
  				if(i<MAX_UNITS)
  				allunits[unitnum].target=i;
  				
  				
  				//only enemies target buildings
  				if(i>=MAX_UNITS&&allunits[unitnum].side!=yourside)
  					allunits[unitnum].target=allunits[i].row*100+allunits[i].col+1000;
  				
  				
  				
  				allunits[unitnum].mode=NEARATTACK;
  				break;
  			}
  			
  			}
  				
  			}
  			
  			
  		}
  		if(allunits[unitnum].mode!=NEARATTACK)
  		allunits[unitnum].curcool=0;

  		
  	}
  	
  	
  
  	//searches to see if target is out of range
  	if(allunits[unitnum].mode==ATTACK||allunits[unitnum].mode==NEARATTACK){
  		
  	
  	if(allunits[unitnum].target<1000){
  	side_a=abs(allunits[unitnum].x-allunits[allunits[unitnum].target].x);
  	side_b=abs(allunits[unitnum].y-allunits[allunits[unitnum].target].y);
  	}
  	else
  	{
  			side_a=abs(allunits[unitnum].x-(((allunits[unitnum].target-1000)-((allunits[unitnum].target-1000)/100*100))*16+8));
				side_b=abs(allunits[unitnum].y-(((allunits[unitnum].target-1000))/100*16+8));
  	}
  	
  		if(sqrt(side_a*side_a+side_b*side_b)<allwarheads[allunittypes[allunits[unitnum].type].wartype].range+16*allunits[unitnum].move)	
			{
		allunits[unitnum].findestcol=allunits[unitnum].destcol;
  	allunits[unitnum].findestrow=allunits[unitnum].destrow;
		
		if(allunits[unitnum].move==1)
		allunits[unitnum].curcool-=3;  	
  	//allunits[unitnum].destx=allunits[unitnum].destcol*16+8;
  	//allunits[unitnum].desty=allunits[unitnum].destrow*16+8;
  			
			}
		else
		{
			//turrets don't move, so are told to stop
			if(allunittypes[allunits[unitnum].type].speed==0)
			{
		  		allunits[unitnum].move=0;
					allunits[unitnum].mode=STOP;
			}
			
			else{
			if(allunits[unitnum].mode==ATTACK){
			if(allunits[unitnum].target<1000){
			allunits[unitnum].findestcol=allunits[allunits[unitnum].target].col;
  		allunits[unitnum].findestrow=allunits[allunits[unitnum].target].row;
  		}
  		else
  		{
  			allunits[unitnum].findestcol=((((allunits[unitnum].target-1000)-((allunits[unitnum].target-1000)/100*100))));
  			allunits[unitnum].findestrow=((allunits[unitnum].target-1000))/100;
  		}
  		
  		allunits[unitnum].move=1;
  		allunits[unitnum].curcool=0;
			}
			else
			{
				allunits[unitnum].findestcol=allunits[unitnum].destcol;
  			allunits[unitnum].findestrow=allunits[unitnum].destrow;
				allunits[unitnum].curcool=0;
				allunits[unitnum].move=1;
  		
			}
			}
			
		}
		}
  	
  	
  }
  
	
	
	
	
	
	//set direction for attack right before unit fires
  if((allunits[unitnum].mode==ATTACK||allunits[unitnum].mode==NEARATTACK)&&allunits[unitnum].curcool<allwarheads[allunittypes[allunits[unitnum].type].wartype].cooldown&&
  allunits[unitnum].curcool>allwarheads[allunittypes[allunits[unitnum].type].wartype].cooldown-2&&allunits[unitnum].move==0
  )
  {
  	
  
	//set unit direction to fire
	if(allunits[unitnum].target<MAX_UNITS){
	side_a=allunits[allunits[unitnum].target].x-allunits[unitnum].x;
	side_b=allunits[allunits[unitnum].target].y-allunits[unitnum].y;
	}
	//for buildings
	else
	{
		side_b=((allunits[unitnum].target-1000)/100*16+8)-(allunits[unitnum].y);
		side_a=(((allunits[unitnum].target-1000)-((allunits[unitnum].target-1000)/100*100)))*16+8
		-(allunits[unitnum].x);
	}
	
	//check for zero
	if(side_a==0) side_a=1;
	if(side_b==0) side_b=1;
	
	
	if(side_a>=0){
	
	allunits[unitnum].destdir=1125+(atan(side_b/side_a)*573);
	}	
		
	if(side_a<0){
	allunits[unitnum].destdir=2925+(atan(side_b/side_a)*573);	
	}
	
	if(allunits[unitnum].destdir>3600) allunits[unitnum].destdir-=3600;
	
	}
  
  
  
  //fire
  if(abs(allunits[unitnum].direction-allunits[unitnum].destdir)<=allunittypes[allunits[unitnum].type].rotate
  &&(allunits[unitnum].mode==ATTACK||allunits[unitnum].mode==NEARATTACK)&&allunits[unitnum].curcool>=allwarheads[allunittypes[allunits[unitnum].type].wartype].cooldown&&allunits[unitnum].move==0)
  {
  	
  for(bulletnum=1;bulletnum<MAX_BULLETS;bulletnum++)
  {
  	if(allbullets[bulletnum].on==0) break;
  }
  
  allbullets[bulletnum].speed=allwarheads[allunittypes[allunits[unitnum].type].wartype].speed;
  
  allbullets[bulletnum].bulletpic=allwarheads[allunittypes[allunits[unitnum].type].wartype].bulletpic;
  
  //for bullets with multiple pics
  if(allbullets[bulletnum].bulletpic==2||allbullets[bulletnum].bulletpic==10)
  {
  	allbullets[bulletnum].bulletpic+=(allunits[unitnum].direction)/450;
  }
  
  allbullets[bulletnum].wartype=allunittypes[allunits[unitnum].type].wartype;
  
  
  if(allunits[unitnum].target<MAX_UNITS){
  allbullets[bulletnum].endx=allunits[allunits[unitnum].target].x+random(allwarheads[allunittypes[
  allunits[unitnum].type].wartype].accuracy)*pow((-1),random(2)+1);
  
	allbullets[bulletnum].endy=allunits[allunits[unitnum].target].y+random(allwarheads[allunittypes[
  allunits[unitnum].type].wartype].accuracy)*pow((-1),random(2)+1);
	}
	
	//for buildings
	else
	{
		allbullets[bulletnum].endx=((allunits[unitnum].target-1000)-((allunits[unitnum].target-1000)/100*100))*16+8+random(allwarheads[allunittypes[
  allunits[unitnum].type].wartype].accuracy)*pow((-1),random(2)+1);
		allbullets[bulletnum].endy=((allunits[unitnum].target-1000))/100*16+8+random(allwarheads[allunittypes[
  allunits[unitnum].type].wartype].accuracy)*pow((-1),random(2)+1);
	}
	
	
  allbullets[bulletnum].startx=allunits[unitnum].x;
 	allbullets[bulletnum].starty=allunits[unitnum].y;
	
	allbullets[bulletnum].a=allbullets[bulletnum].endx-allbullets[bulletnum].startx;
	allbullets[bulletnum].b=allbullets[bulletnum].endy-allbullets[bulletnum].starty;
	
	//check for zero
	if(allbullets[bulletnum].a==0) allbullets[bulletnum].a=1;
	if(allbullets[bulletnum].b==0) allbullets[bulletnum].b=1;
	
	side_a=allbullets[bulletnum].a;
	side_b=allbullets[bulletnum].b;
	
	allunits[unitnum].curcool=0;
	
	if(sqrt(side_a*side_a+side_b*side_b)<180)	
	{
		
	
	allbullets[bulletnum].c=sqrt(side_a*side_a+side_b*side_b);
	
		//check for zero
	if(allbullets[bulletnum].c==0) allbullets[bulletnum].c=1;
  	
  	allbullets[bulletnum].on=1;
  	
  }
  }
	
	
	
	//stop unit if reach destination
	if(allunits[unitnum].x==allunits[unitnum].destx&&allunits[unitnum].y==allunits[unitnum].desty&&
	allunits[unitnum].destcol==allunits[unitnum].findestcol&&allunits[unitnum].destrow==allunits[unitnum]
	.findestrow&&allunits[unitnum].move==1)
	{
		allunits[unitnum].curcool-=2;
		allunits[unitnum].move=0;
		
		if(allunits[unitnum].mode!=ATTACK)
		allunits[unitnum].mode=STOP;
		
		if(allunits[unitnum].type==HARV)  //harvester
	{
		
		//harvester is at refinery
		if(allunits[map[allunits[unitnum].row-1][allunits[unitnum].col]].type==6&&allunits[unitnum].store>0)
		{

			allunits[unitnum].destdir=2025;
			allunits[unitnum].mode=STOP;
			allunits[unitnum].curcool=0;
		
		}
		
		//at tiberium
		if(tmap[allunits[unitnum].row][allunits[unitnum].col]>0)
		{
			allunits[unitnum].mode=HARVEST;
			allunits[unitnum].curcool=0;
		}
		
		
		
		
	}
		
		
		
		
	}
	
	//allunits[unitnum].move=0;
  
  
  
  	
	
	
	//if unit is not at final destination
	if((allunits[unitnum].x!=allunits[unitnum].destx||allunits[unitnum].y!=allunits[unitnum].desty)
	||(allunits[unitnum].col!=allunits[unitnum].findestcol||allunits[unitnum].row!=allunits[unitnum].findestrow))
	{
  
  
  
	
	
  allunits[unitnum].curspeed++;
  

  if(allunits[unitnum].curspeed>=allunittypes[allunits[unitnum].type].speed) {
  allunits[unitnum].curspeed=0;
  
  
  
  //selects destination
  if(allunits[unitnum].x==allunits[unitnum].destx&&allunits[unitnum].y==allunits[unitnum].desty&&
  (allunits[unitnum].col!=allunits[unitnum].findestcol||allunits[unitnum].row!=allunits[unitnum].findestrow)) 
  {
  	

k=allunits[unitnum].col-allunits[unitnum].findestcol;
l=allunits[unitnum].row-allunits[unitnum].findestrow;
  
 
  	//only move diagonal when close to destination
  	if(abs(k)==abs(l))
  	{
  		
  	
  	//SW
  	if(k>0&&l<0)
  	{
  		sprintf(moveorder,"54637201");
  		
  	}
  	
  
  	//SE
  	if(k<0&&l<0)
  	{
  		sprintf(moveorder,"34251607");
  		 		
  	}
  	
  	//NE
  	if(k<0&&l>0)
  	{
  				sprintf(moveorder,"10273645");
  		
  	}

  	
  	//NW
  	if(k>0&&l>0)
  	{
  		sprintf(moveorder,"70615243");
  	
  		
  	}
  	
  	
  	}
  	else{
  	
  	//E
  	if(k<0&&abs(k)>=abs(l))
  	{
  		if(l>0)	sprintf(moveorder,"2107654");
  		if(l==0)	sprintf(moveorder,"21304756");
  		if(l<0)	sprintf(moveorder,"23456701");
  		
  				
  	}
  	
  	  	
  	//N
  	if(abs(k)<abs(l)&&l>0)
  	{
  		if(k>0)	sprintf(moveorder,"07654321");
  		if(k==0)	sprintf(moveorder,"07162534");
  		if(k<0)	sprintf(moveorder,"01234567");
  	}
  	
  	
  	
  	//W
  	if(k>0&&abs(k)>=abs(l))
  	{
  		if(l>0)	sprintf(moveorder,"67012345");
  		if(l==0)	sprintf(moveorder,"67504132");
  		if(l<0)	sprintf(moveorder,"65432107");
  		
  	}
  	
  	
  	//S
  	if(abs(k)<abs(l)&&l<0)
  	{
  		if(k>0)	sprintf(moveorder,"45670123");
  		if(k==0)	sprintf(moveorder,"45362710");
  		if(k<0)	sprintf(moveorder,"43210765");
  	
  	}
  
  	}
  
  
  j=0;
  	for(i=0;i<8;i++)
	{
	switch(moveorder[i])
	{
		
		
  	
  	//N
  	case 48:
  	if(map[allunits[unitnum].row-1][allunits[unitnum].col]==0&&allunits[unitnum].row>0)
  	{
  		allunits[unitnum].destcol=allunits[unitnum].col;
  		allunits[unitnum].destrow=allunits[unitnum].row-1;
  		allunits[unitnum].destdir=225;  	
  		j=8;	
  	}
  	break;
  	
  	//NW
  	case 55:
  	if(map[allunits[unitnum].row-1][allunits[unitnum].col-1]==0&&allunits[unitnum].row>0&&allunits[unitnum].col>0)
  	{
  		allunits[unitnum].destcol=allunits[unitnum].col-1;
  		allunits[unitnum].destrow=allunits[unitnum].row-1;
  		allunits[unitnum].destdir=3375;  		
  		j=8;
  	}
  	break;
  	
  	//W
  	case 54:
		if(map[allunits[unitnum].row][allunits[unitnum].col-1]==0&&allunits[unitnum].col>0)
  	  	{
  		allunits[unitnum].destcol=allunits[unitnum].col-1;
  		allunits[unitnum].destrow=allunits[unitnum].row;
  		allunits[unitnum].destdir=2925;  	
  		j=8;	
  	}
  	break;
  	
  	//SW
  	case 53:
  	if(map[allunits[unitnum].row+1][allunits[unitnum].col-1]==0&&allunits[unitnum].col>0&&allunits[unitnum].row<mapheight-1)
  	{
  		allunits[unitnum].destcol=allunits[unitnum].col-1;
  		allunits[unitnum].destrow=allunits[unitnum].row+1;
  		allunits[unitnum].destdir=2475;  		
  		j=8;
  	}
  	break;
  	
  	//S
  	case 52:
  	if(map[allunits[unitnum].row+1][allunits[unitnum].col]==0&&allunits[unitnum].row<mapheight-1)
  	{
  		allunits[unitnum].destcol=allunits[unitnum].col;
  		allunits[unitnum].destrow=allunits[unitnum].row+1;
  		allunits[unitnum].destdir=2025;  		
  		j=8;
  	}
  	break;
  	
  	//SE
  	case 51:
  	if(map[allunits[unitnum].row+1][allunits[unitnum].col+1]==0&&allunits[unitnum].row<mapheight-1&&allunits[unitnum].col<mapwidth-1)
  	{
  		allunits[unitnum].destcol=allunits[unitnum].col+1;
  		allunits[unitnum].destrow=allunits[unitnum].row+1;
  		allunits[unitnum].destdir=1575;  		
  		j=8;
  	}
  	break;
  	
  	//E
  	case 50:
  	if(map[allunits[unitnum].row][allunits[unitnum].col+1]==0&&allunits[unitnum].col<mapwidth-1)
  	{
  		allunits[unitnum].destcol=allunits[unitnum].col+1;
  		allunits[unitnum].destrow=allunits[unitnum].row;
  		allunits[unitnum].destdir=1125;  	
  		j=8;	
  	}
  	break;
  	
  	//NE
  	case 49:
  	if(map[allunits[unitnum].row-1][allunits[unitnum].col+1]==0&&allunits[unitnum].row>0&&allunits[unitnum].col<mapwidth-1)
  	{
  		allunits[unitnum].destcol=allunits[unitnum].col+1;
  		allunits[unitnum].destrow=allunits[unitnum].row-1;
  		allunits[unitnum].destdir=675;  	
  		j=8;	
  	}
  	break;
  	
  	
  	
  }
  
  if(j==8) break;
  	
  
  }	
  
  
  //if space is taken and near destination and destination is taken
  if(i>0&&abs(allunits[unitnum].col-allunits[unitnum].findestcol)+
  abs(allunits[unitnum].row-allunits[unitnum].findestrow)<3&&
  map[allunits[unitnum].findestrow][allunits[unitnum].findestcol]!=0)
  {
  	//engineer takes building or commando destroys building
  	if(abs(allunits[unitnum].col-allunits[unitnum].findestcol)+
  abs(allunits[unitnum].row-allunits[unitnum].findestrow)<2&&allunittypes[allunits[map[allunits[unitnum].findestrow]
  [allunits[unitnum].findestcol]].type].speed<=3&&allunits[map[allunits[unitnum].findestrow]
  [allunits[unitnum].findestcol]].side!=yourside)
  	{
  	
  		if(allunits[unitnum].type==ENGINEER){
  		allunits[map[allunits[unitnum].findestrow][allunits[unitnum].findestcol]].side=allunits[unitnum].side;
			allunits[unitnum].hp=0;
			killdead=1;
			}

			if(allunits[unitnum].type==COMMANDO)
			{
				allunits[map[allunits[unitnum].findestrow][allunits[unitnum].findestcol]].hp=-1;
				killdead=1;
			}
			 		
  	}
  	
  	
  	
  	allunits[unitnum].findestcol=allunits[unitnum].destcol;	
  	allunits[unitnum].findestrow=allunits[unitnum].destrow;	
  	//allunits[unitnum].destcol=allunits[unitnum].col;	
  	//allunits[unitnum].destrow=allunits[unitnum].row;	
  	//allunits[unitnum].destdir=allunits[unitnum].direction;	
  	
  }
  
  
  allunits[unitnum].destx=allunits[unitnum].destcol*16+8;
  allunits[unitnum].desty=allunits[unitnum].destrow*16+8;
  //map[allunits[unitnum].row][allunits[unitnum].col]=0;
  map[allunits[unitnum].destrow][allunits[unitnum].destcol]=unitnum;
  
  
  
  //allunits[unitnum].mode=MOVE;
  //allunits[unitnum].move=1;
  }
  
  
  
  
 	//moves unit
  	if(abs(allunits[unitnum].direction-allunits[unitnum].destdir)<=allunittypes[allunits[unitnum].type].rotate)
  {
  	GraySprite16(allunits[unitnum].x-8,allunits[unitnum].y-8,pics+32*(allunittypes[allunits[unitnum].type].pic+((allunits[unitnum].direction)/450+allunits[unitnum].step)),0,allunits[unitnum].side);
		
 	if(allunits[unitnum].select==1) { 		
 	drawhealth(allunits[unitnum].x-8,allunits[unitnum].y-8,allunits[unitnum].hp,
 	allunittypes[allunits[unitnum].type].maxhp,allunittypes[allunits[unitnum].type].speed,allunits[unitnum].store,allunittypes[allunits[unitnum].type].maxstore);	
	}
	
	if(allunits[unitnum].side!=yourside)  putbadmark(allunits[unitnum].x,allunits[unitnum].y);
	if(allunittypes[allunits[unitnum].type].rotate>25)  puticonmark(allunits[unitnum].x,allunits[unitnum].y,allunittypes[allunits[unitnum].type].icon);
	
  	if(allunits[unitnum].x>allunits[unitnum].destx) allunits[unitnum].x--;
	  if(allunits[unitnum].x<allunits[unitnum].destx) allunits[unitnum].x++;
 	 	if(allunits[unitnum].y>allunits[unitnum].desty) allunits[unitnum].y--;
  	if(allunits[unitnum].y<allunits[unitnum].desty) allunits[unitnum].y++;	
  	
  	
  	
  	//alternate pic for infantry
  	if(allunittypes[allunits[unitnum].type].rotate>=20)
  	{
  		if(checkforeven(allunits[unitnum].direction/450+allunits[unitnum].step))  allunits[unitnum].step++;
  		else  allunits[unitnum].step--;	
  	}
  	
  	
  
  	
  	
  	 GraySprite16(allunits[unitnum].x-8,allunits[unitnum].y-8,pics+32*(allunittypes[allunits[unitnum].type].pic+((allunits[unitnum].direction)/450+allunits[unitnum].step)),0,allunits[unitnum].side);
  	
  	
	
	if(allunits[unitnum].select==1) { 		
 	drawhealth(allunits[unitnum].x-8,allunits[unitnum].y-8,allunits[unitnum].hp,
 	allunittypes[allunits[unitnum].type].maxhp,allunittypes[allunits[unitnum].type].speed,allunits[unitnum].store,allunittypes[allunits[unitnum].type].maxstore);	
	
	}
	
	if(allunits[unitnum].side!=yourside)  putbadmark(allunits[unitnum].x,allunits[unitnum].y);
		if(allunittypes[allunits[unitnum].type].rotate>25)  puticonmark(allunits[unitnum].x,allunits[unitnum].y,allunittypes[allunits[unitnum].type].icon);

	
	//unit is moving
	allunits[unitnum].move=1;
	
  	
  }
  else 
  {
  	allunits[unitnum].move=0;
  }
  
  
  
  
  allunits[unitnum].col=(allunits[unitnum].x)/16;
  allunits[unitnum].row=(allunits[unitnum].y)/16;
  
  
  //unit is in new square
  if((allunits[unitnum].col!=allunits[unitnum].oldcol||allunits[unitnum].row!=allunits[unitnum].oldrow)&&
  allunits[unitnum].col==allunits[unitnum].destcol&&allunits[unitnum].row==allunits[unitnum].destrow)
  {
  
  
  	
  if(map[allunits[unitnum].oldrow][allunits[unitnum].oldcol]<MAX_UNITS)  //if not right out of the factory
  map[allunits[unitnum].oldrow][allunits[unitnum].oldcol]=0;
  
  //map[allunits[unitnum].row][allunits[unitnum].col]=unitnum;
  allunits[unitnum].oldrow=allunits[unitnum].row;
  allunits[unitnum].oldcol=allunits[unitnum].col;
	
	
	
	
	
  if(allunits[unitnum].side==yourside)
  {
  if(fogremover(allunits[unitnum].col,allunits[unitnum].row,allunittypes[allunits[unitnum].type].sight))
  {
  	redraw=1;
  }
	}
  	
	}
  
  
  
  }
  }
  
  }
  }
  

  
  //redraw cursor if moved and not scrooling
	if((oldcol!=col||oldrow!=row||oldcurset!=curset)&&arrow==0) {
	
	if(oldcurset<50)
	CursorSprite16(oldcol,oldrow,cursor+32*oldcurset,0);	
	if(oldcurset==50)
	drawbuilding((oldcol+curmapx+8)/16*16,(oldrow+curmapy+8)/16*16,allunittypes[allbuilders[0].type].speed,
	allunittypes[allbuilders[0].type].rotate,allunittypes[allbuilders[0].type].pic,1,yourside,0);
	
	if(curset<50)
	CursorSprite16(col,row,cursor+32*curset,0);	
	if(curset==50)
	drawbuilding((col+curmapx+8)/16*16,(row+curmapy+8)/16*16,allunittypes[allbuilders[0].type].speed,
	allunittypes[allbuilders[0].type].rotate,allunittypes[allbuilders[0].type].pic,1,yourside,0);
	
	}
	
	
	//if not scrollingcopy to old
	if(arrow==0)
	{
	oldcurset=curset;
	oldrow=row;
	oldcol=col;
	}
	
	
	
	
	} while(exit==0);

	
	
	
endgame();



LCD_restore (buffer);
return;
	
}



